FINETUNE_ACTIVE = 1
FILTER_ACTIVE = 1	;This also controls volume LFO

version_number = $1010

v1_fq_lo = $d400
v1_fq_hi = $d401
v1_pw_lo = $d402
v1_pw_hi = $d403
v1_wf = $d404
v1_ad = $d405
v1_sr = $d406

v2_fq_lo = $d407
v2_fq_hi = $d408
v2_pw_lo = $d409
v2_pw_hi = $d40a
v2_wf = $d40b
v2_ad = $d40c
v2_sr = $d40d

v3_fq_lo = $d40e
v3_fq_hi = $d40f
v3_pw_lo = $d410
v3_pw_hi = $d411
v3_wf = $d412
v3_ad = $d413
v3_sr = $d414

fi_fq_lo = $d415
fi_fq_hi = $d416
fi_rs_ch = $d417
fi_mo_vo = $d418

v3_wf_out = $d41b
v3_en_out = $d41c

;default zeropages for player
zp_idx_lo = $fe
zp_idx_hi = $ff


;----------------------
;sequencer data
;----------------------
up00 = $e0
up01 = $e1
up02 = $e2
up03 = $e3
up04 = $e4
up05 = $e5
up06 = $e6
up07 = $e7
up08 = $e8
up09 = $e9
up0a = $ea
up0b = $eb
up0c = $ec
up0d = $ed
up0e = $ee
up0f = $ef

;dwn00 = $c0
dwn00 = $d0;;ONLY FOR EDITOR
dwn01 = $df
dwn02 = $de
dwn03 = $dd
dwn04 = $dc
dwn05 = $db
dwn06 = $da
dwn07 = $d9
dwn08 = $d8
dwn09 = $d7
dwn0a = $d6
dwn0b = $d5
dwn0c = $d4
dwn0d = $d3
dwn0e = $d2
dwn0f = $d1

rpt00 = $f0
rpt01 = $f1
rpt02 = $f2
rpt03 = $f3
rpt04 = $f4
rpt05 = $f5
rpt06 = $f6
rpt07 = $f7
rpt08 = $f8
rpt09 = $f9
rpt0a = $fa
rpt0b = $fb
rpt0c = $fc
rpt0d = $fd

;loop = $fe
empty = $ff


;----------------------
;pattern data
;----------------------
;notes
nonote = $00

c0 = $01
cs0 = $02
d0 = $03
ds0 = $04
e0 = $05
f0 = $06
fs0 = $07
g0 = $08
gs0 = $09
a0 = $0a
as0 = $0b
b0 = $0c

c1 = $0d
cs1 = $0e
d1 = $0f
ds1 = $10
e1 = $11
f1 = $12
fs1 = $13
g1 = $14
gs1 = $15
a1 = $16
as1 = $17
b1 = $18

c2 = $19
cs2 = $1a
d2 = $1b
ds2 = $1c
e2 = $1d
f2 = $1e
fs2 = $1f
g2 = $20
gs2 = $21
a2 = $22
as2 = $23
b2 = $24

c3 = $25
cs3 = $26
d3 = $27
ds3 = $28
e3 = $29
f3 = $2a
fs3 = $2b
g3 = $2c
gs3 = $2d
a3 = $2e
as3 = $2f
b3 = $30

c4 = $31
cs4 = $32
d4 = $33
ds4 = $34
e4 = $35
f4 = $36
fs4 = $37
g4 = $38
gs4 = $39
a4 = $3a
as4 = $3b
b4 = $3c

c5 = $3d
cs5 = $3e
d5 = $3f
ds5 = $40
e5 = $41
f5 = $42
fs5 = $43
g5 = $44
gs5 = $45
a5 = $46
as5 = $47
b5 = $48

c6 = $49
cs6 = $4a
d6 = $4b
ds6 = $4c
e6 = $4d
f6 = $4e
fs6 = $4f
g6 = $50
gs6 = $51
a6 = $52
as6 = $53
b6 = $54

c7 = $55
cs7 = $56
d7 = $57
ds7 = $58
e7 = $59
f7 = $5a
fs7 = $5b
g7 = $5c
gs7 = $5d
a7 = $5e
as7 = $5f
;b7 = n/a

;instruments
ins00 = $60
ins01 = $61
ins02 = $62
ins03 = $63
ins04 = $64
ins05 = $65
ins06 = $66
ins07 = $67
ins08 = $68
ins09 = $69
ins0a = $6a
ins0b = $6b
ins0c = $6c
ins0d = $6d
ins0e = $6e
ins0f = $6f
ins10 = $70
ins11 = $71
ins12 = $72
ins13 = $73
ins14 = $74
ins15 = $75
ins16 = $76
ins17 = $77
ins18 = $78
ins19 = $79
ins1a = $7a
ins1b = $7b
ins1c = $7c
ins1d = $7d
ins1e = $7e
ins1f = $7f

;durations
dur00 = $80
dur01 = $81
dur02 = $82
dur03 = $83
dur04 = $84
dur05 = $85
dur06 = $86
dur07 = $87
dur08 = $88
dur09 = $89
dur0a = $8a
dur0b = $8b
dur0c = $8c
dur0d = $8d
dur0e = $8e
dur0f = $8f
dur10 = $90
dur11 = $91
dur12 = $92
dur13 = $93
dur14 = $94
dur15 = $95
dur16 = $96
dur17 = $97
dur18 = $98
dur19 = $99
dur1a = $9a
dur1b = $9b
dur1c = $9c
dur1d = $9d
dur1e = $9e
dur1f = $9f
dur20 = $a0
dur21 = $a1
dur22 = $a2
dur23 = $a3
dur24 = $a4
dur25 = $a5
dur26 = $a6
dur27 = $a7
dur28 = $a8
dur29 = $a9
dur2a = $aa
dur2b = $ab
dur2c = $ac
dur2d = $ad
dur2e = $ae
dur2f = $af
dur30 = $b0
dur31 = $b1
dur32 = $b2
dur33 = $b3
dur34 = $b4
dur35 = $b5
dur36 = $b6
dur37 = $b7
dur38 = $b8
dur39 = $b9
dur3a = $ba
dur3b = $bb
dur3c = $bc
dur3d = $bd
dur3e = $be
dur3f = $bf

dur40 = $c0
dur41 = $c1
dur42 = $c2
dur43 = $c3
dur44 = $c4
dur45 = $c5
dur46 = $c6
dur47 = $c7
dur48 = $c8
dur49 = $c9
dur4a = $ca
dur4b = $cb
dur4c = $cc
dur4d = $cd
dur4e = $ce
dur4f = $cf
dur50 = $d0
dur51 = $d1
dur52 = $d2
dur53 = $d3
dur54 = $d4
dur55 = $d5
dur56 = $d6
dur57 = $d7
dur58 = $d8
dur59 = $d9
dur5a = $da
dur5b = $db
dur5c = $dc
dur5d = $dd
dur5e = $de
dur5f = $df

;pattern instructions direct
gateoff = $e0	
gateon = $e1	
gliup = $e2	;$40
glido = $e3	;$60
glito = $e4	;$80
tie = $e5	;$a0
speed = $e6	
freefree = $e7	;because of editor, max 3 bits. CMD $e7 still free
;unused = $e8 - $ef

;pattern instrument programs
prgads = $f0 
prgpor = $f1
prgwav = $f2
prgfre = $f3
prgpul = $f4
prgfil = $f5
prghar = $f6
;unused = $f7 - $fe

end = $ff	;pattern end marker

;----------------------
;instrument table commands
;----------------------
stop = $ff
loop = $fe
wait = $fd
depth = $fd	

setad = $fc
finetune = $fc
up = $fc

setsr = $fb
down = $fb

;route = $fa	;not yet used, could read d41b and d41c and route it to an instrument program
;repeat = $fa	;not yet used, could repeat a segment x times before going to the next segment
volume = $fa


	
	*=$0801	
basic_start
	.word basic_end
project_version
	.word version_number	
	.null $9e,^music_player
basic_end	.word 0


		
	
music_player	
	sei
	jsr $fda3	;reinit
	
	jsr $e544
	
	lda #0
	
music_player_init_song
	sta music_player_temp+1	
	jsr init_song
	

	ldy v123_multi_speed 
	lda player_speed_lo,y
	sta $dd04
	lda player_speed_hi,y	
	sta $dd05

	
		
	lda #<irq_0
	sta $0318 
	lda #>irq_0 
	sta $0319
	ldx #$81
	stx $dd0d
	stx $0291
		
-	lda $d012
	cmp #$fb
	bcc -
	stx $dd0e
	
	
	
	
	
	
music_player_interface
	
		
	lda #$0c
	sta $0286	;color
	
	
	jsr $e566	;home cursor
	ldx #$00	;non-reverse
	;stx $C7
-	
	lda project_header,x
	beq +
	jsr $ffd2
	inx
	bne -
+	
	tax
	lda #$0d
	jsr $ffd2
-	
	lda #$0d
	sta $0286
	jsr $ffd2
	

	txa
	lsr
	lsr
	lsr
	lsr	
	tay
music_player_temp
	cpy #0
	bne +
	lda #$01
	sta $0286	
+	
	
	lda player_song_keys,y
	jsr $ffd2

	lda #"."
	jsr $ffd2

	lda #" "
	jsr $ffd2
	
-	
	lda song_names,x
	cmp #$20
	bcs +
	ora #$40
+	jsr $ffd2
	
	inx
	cpx #$f0
	beq +
	txa
	and #$0f
	bne -
	beq --
+

	lda #$0d
	sta $0286	
	jsr $ffd2
	
;	ldx #0
;-	lda $A364,x	;ok message
;	beq +
;	jsr $ffd2
;	inx
;	bne -
;+		
;	lda #$63
;	jsr $ffd2

-	
	jsr $ea87
	jsr $ffe4	;get key
	beq -
	sta mpt+1
	
	ldy #0
-	
	lda player_song_keys,y
	beq music_player_interface
	iny
mpt	cmp #0
	bne -
	
	
	;txa
	sbc #$41
	ldx #0
	stx $dd0e
	jmp music_player_init_song
	
;---------------------------------------------	
irq_0
	pha
	txa
	pha
	tya
	pha
	

	lda #$0c
	sta $d020
	jsr play_song
do2o	lda #$0b
	sta $d020
	sta $d021
	
	
	bit $dd0d

		
	jmp $ea81



player_speed_lo	.byte $c7,$63,$97,$31
player_speed_hi	.byte $4c,$26,$19,$13	

player_song_keys
	.enc screen
	.TEXT "abcdefghijklmno",0
	.enc none
			
		


	*=$0900
music_routine_start
	
init_song	jmp song_init
play_song	jmp song_play

pattern_command_indirect
	.word gateoff_exe,gateon_exe,gliup_exe,glido_exe,glito_exe,tie_exe,speed_exe

adsr_jump_table_indirect
	.word osc_program_exe
	.word adsr_loop
	.word adsr_wait
	.word set_ad_value
	.word set_sr_value
osc_jump_table_indirect
	.word freq_program_exe
	.word osc_loop
	.word osc_wait
freq_jump_table_indirect
	.word pw_program_exe
	.word freq_loop
	.word freq_wait
	.word freq_fine
pw_jump_table_indirect
	.if FILTER_ACTIVE
	.word filter_program_exe
	.else
	.word porta_program_exe
	.fi
	.word pw_loop
	.word pw_depth
	.word pw_up
	.word pw_down
filter_jump_table_indirect
	.if FILTER_ACTIVE
	.word porta_program_exe
	.word filter_loop
	.word filter_depth
	.word filter_up
	.word filter_down
	.word filter_volume
	.fi
porta_jump_table_indirect
	.word porta_program_set_values
	.word porta_loop
	.word porta_depth
	.word porta_up
	.word porta_down

	
;===============================
pattern_command_instrument_direct_bits
	.byte %00000010	;adsr
	.byte %01000000	;porta
	.byte %00000100	;osc
	.byte %00001000	;freq
	.byte %00010000	;pw
	.byte %00100000	;filter
	.byte %00000001	;hard				
	
	
;player temp tables
	
v123_current_song
	.byte 0
v123_multi_speed
	.byte 0,0	
channel_parameters_begin			
v1_song_patterns	
	.byte 0
v1_song_pos	
	.byte 0
v1_pattern_lo	
	.byte 0
v1_pattern_hi	
	.byte 0
v1_filter_volume
	.byte 0
v1_channel_and		
	.byte $ff
v1_instrument
	.byte $00
	
v2_song_patterns	
	.byte 2
v2_song_pos	
	.byte 0
v2_pattern_lo	
	.byte 0
v2_pattern_hi	
	.byte 0
v2_filter_volume	
	.byte 0
v2_channel_and	
	.byte $ff
v2_instrument
	.byte $00
		
v3_song_patterns	
	.byte 4
v3_song_pos	
	.byte 0
v3_pattern_lo	
	.byte 0
v3_pattern_hi	
	.byte 0
v3_filter_volume	
	.byte 0
v3_channel_and	
	.byte $ff
v3_instrument
	.byte $00

		
v1_pattern_speed_timer
	.byte $01
v1_pattern_speed_pos
	.byte $00
v1_pattern_transpose
	.byte $00
v1_pattern_pos	
	.byte $00
v1_pattern_repeat
	.byte $00
v1_fine_tune	
	.byte $00
v1_1st_frame	
	.byte $00


				
v2_pattern_speed_timer
	.byte $01
v2_pattern_speed_pos
	.byte $00
v2_pattern_transpose
	.byte $00
v2_pattern_pos	
	.byte $00
v2_pattern_repeat
	.byte $00
v2_fine_tune
	.byte $00
v2_1st_frame
	.byte $00

			
v3_pattern_speed_timer
	.byte $01
v3_pattern_speed_pos
	.byte $00
v3_pattern_transpose
	.byte $00
v3_pattern_pos	
	.byte $00
v3_pattern_repeat
	.byte $00
v3_fine_tune
	.byte $00
v3_1st_frame	
	.byte $00


v1_note_buffer
	.byte $00
v1_note_base
	.byte $00	
v1_dur_buffer
	.byte $00
v1_dur_timer	
	.byte $00
v1_pw_lfo_depth
	.byte $00
v1_filter_lfo_depth
	.byte $00
v1_porta_lfo_depth
	.byte $00

v2_note_buffer
	.byte $00
v2_note_base
	.byte $00	
v2_dur_buffer
	.byte $00
v2_dur_timer	
	.byte $00
v2_pw_lfo_depth
	.byte $00
v2_filter_lfo_depth
	.byte $00
v2_porta_lfo_depth
	.byte $00
	
v3_note_buffer
	.byte $00
v3_note_base
	.byte $00
v3_dur_buffer
	.byte $00
v3_dur_timer	
	.byte $00
v3_pw_lfo_depth
	.byte $00
v3_filter_lfo_depth
	.byte $00
v3_porta_lfo_depth
	.byte $00


v1_program_init_flags
	.byte $00			
v1_osc_buffer
	.byte $00
v1_pw_lo_buffer
	.byte $00
v1_pw_hi_buffer
	.byte $00	
v1_freq_lo_buffer
	.byte $00
v1_freq_hi_buffer
	.byte $00
v1_note_target	
	.byte $00
	

v2_program_init_flags
	.byte $00
v2_osc_buffer
	.byte $00
v2_pw_lo_buffer
	.byte $00
v2_pw_hi_buffer
	.byte $00	
v2_freq_lo_buffer
	.byte $00
v2_freq_hi_buffer
	.byte $00
v2_note_target	
	.byte $00

	
v3_program_init_flags
	.byte $00
v3_osc_buffer
	.byte $00
v3_pw_lo_buffer
	.byte $00
v3_pw_hi_buffer
	.byte $00	
v3_freq_lo_buffer
	.byte $00
v3_freq_hi_buffer
	.byte $00		
v3_note_target	
	.byte $00


v1_adsr_program_pos
	.byte $00
v1_porta_program_pos
	.byte $00	
v1_osc_program_pos
	.byte $00
v1_freq_program_pos  
	.byte $00
v1_pw_program_pos
	.byte $00
v1_filter_program_pos
	.byte $00
v1_hard_program_pos	
	.byte $00
	
v2_adsr_program_pos
	.byte $00
v2_porta_program_pos
	.byte $00
v2_osc_program_pos
	.byte $00
v2_freq_program_pos  
	.byte $00
v2_pw_program_pos
	.byte $00
v2_filter_program_pos
	.byte $00
v2_hard_program_pos
	.byte $00
	
v3_adsr_program_pos
	.byte $00
v3_porta_program_pos
	.byte $00
v3_osc_program_pos
	.byte $00
v3_freq_program_pos  
	.byte $00
v3_pw_program_pos
	.byte $00
v3_filter_program_pos
	.byte $00
v3_hard_program_pos
	.byte $00
	

v1_adsr_program_hold_timer
	.byte $00
v1_porta_lfo_length
	.byte $00	
v1_osc_program_hold_timer
	.byte $00
v1_freq_program_hold_timer
	.byte $00	
v1_pw_lfo_length
	.byte $00
v1_filter_lfo_length
	.byte $00
v1_hard_restart_timer
	.byte $00
	
v2_adsr_program_hold_timer
	.byte $00
v2_porta_lfo_length
	.byte $00	
v2_osc_program_hold_timer
	.byte $00
v2_freq_program_hold_timer
	.byte $00	
v2_pw_lfo_length
	.byte $00
v2_filter_lfo_length
	.byte $00
v2_hard_restart_timer
	.byte $00

v3_adsr_program_hold_timer
	.byte $00
v3_porta_lfo_length
	.byte $00	
v3_osc_program_hold_timer
	.byte $00
v3_freq_program_hold_timer
	.byte $00	
v3_pw_lfo_length
	.byte $00
v3_filter_lfo_length
	.byte $00
v3_hard_restart_timer
	.byte $00						

channel_parameters_end
	

;===============================================	
song_init
	asl
	asl
	sta v123_current_song
	clc
	adc #2
	tay

	lda song_pattern_settings+1,y
	lsr
	lsr
	lsr
	lsr
	sta v123_multi_speed
	
	lda #$0f
	sta song_volume+1
	lda #<pattern_list_init
	sta multi_play_loop+1
	
	lda #0
	sta filter_mo+1
	sta filter_rs_ch+1
	sta v123_multi_speed+1
	
	
	ldx #(channel_parameters_end-channel_parameters_begin-1)
-	sta channel_parameters_begin,x
	dex
	bpl -	
	

	ldx #$0e
-	
	lda #$ff
	sta v1_channel_and,x
	sta v1_hard_restart_timer,x
	lda #$08
	sta v1_wf,x
	lda song_pattern_settings,y
	sta v1_song_pos,x
	txa
	lsr
	lsr
	adc #0
	sta v1_song_patterns,x
	lda #1
	sta v1_pattern_speed_timer,x
	
	dey
	txa
	sbx #7
	bpl -
	rts
	
	
	
song_play
	ldx #$0e
	
	lda v123_multi_speed
	beq pattern_list_init
	
	dec v123_multi_speed+1
	bmi song_play_multi_speed_init
	
	lda #<song_play_multi_speed
	sta multi_play_loop+1
	
song_play_multi_speed
	jmp osc_program_exe

song_play_multi_speed_init
	sta v123_multi_speed+1
	
	
	lda #<pattern_list_init
	sta multi_play_loop+1
	
;-------------------------
pattern_list_init
	lda v1_pattern_pos,x
	bne pattern_exe
	
pattern_list_new_value
	ldy v1_song_patterns,x	;y= 0/2/4
	lda song_patterns,y
	sta zp_idx_lo
	lda song_patterns+1,y
	sta zp_idx_hi
	

	ldy v1_song_pos,x
pattern_list_transpose_callback	
	lda (zp_idx_lo),y
	cmp #loop
	beq pattern_list_loop
	bcc pattern_list_loop_callback
pattern_same_tick
	ldy v1_instrument,x
	
	jmp hard_program_exe

pattern_list_loop	
	iny
	lda (zp_idx_lo),y
	sta v1_song_pos,x
	tay
	bcs pattern_list_transpose_callback	
;	lda (zp_idx_lo),y
pattern_list_loop_callback
	cmp #dwn00
	bcc pattern_list_value
	bne +
	;editor needs dwn00=$d0 to distinguish between an up00 and dwn00 but player should give same effect
	adc #$10	
+
	adc #$0f
	;a e0-0f
	bmi pattern_list_transpose

pattern_list_repeat
	
	sta v1_pattern_repeat,x
	bpl pattern_list_repeat_callback

pattern_list_transpose
	;a=$e0-$ff
	adc #$10
	sta v1_pattern_transpose,x

pattern_list_repeat_callback
	iny
	tya
	sta v1_song_pos,x
	bne pattern_list_transpose_callback
	
pattern_list_value
	tay
	lda patterns_lo,y
	sta v1_pattern_lo,x
	lda patterns_hi,y
	sta v1_pattern_hi,x
	 
;==============================	
	
pattern_exe	
	dec v1_pattern_speed_timer,x
	bne pattern_same_tick
	
pattern_speed_done

	dec v1_dur_timer,x
	bpl pattern_same_tick
	
			
init_new_pattern_cmd	

	lda v1_pattern_lo,x
	sta zp_idx_lo
	lda v1_pattern_hi,x
	sta zp_idx_hi

	ldy v1_pattern_pos,x
			
get_next_pattern_cmd	

	lda (zp_idx_lo),y
	bmi pattern_instruction
	
pattern_note_or_instrument	
	beq keep_current_note
	cmp #ins00
	bcc pattern_note

pattern_instrument
	asl
	asl
	asl
	sta v1_instrument,x
	iny
	bcs get_next_pattern_cmd
		
pattern_note		
	adc v1_pattern_transpose,x
	;and #$7f		;in case base note < $10 and transpose negative
	sta v1_note_base,x
	bne pattern_note_set
keep_current_note	
	lda #%01111111
	sta v1_program_init_flags,x	;no-note
	
pattern_note_set	
	
	lda v1_dur_buffer,x
	sta v1_dur_timer,x
	
	iny
	
	lda (zp_idx_lo),y
	eor #$ff
	bne pattern_continue

	tay
	
	lda v1_pattern_repeat,x
	bne pattern_repeat

	inc v1_song_pos,x
	bne pattern_continue
pattern_repeat
	dec v1_pattern_repeat,x
pattern_continue		
	tya
	sta v1_pattern_pos,x
	jmp hard_restart_init
	
pattern_instruction
	iny
	cmp #gateoff
	bcs pattern_instruction_command

pattern_dur	
	anc #$7f
	sta v1_dur_buffer,x
	bcc get_next_pattern_cmd
	
	
pattern_instruction_command		
	cmp #prgads
	bcc pattern_command

instrument_table_direct
	
	;in A: instrument_direct_command $f0-$f6
	;in C: 1
	
	adc #<pattern_command_instrument_direct_bits+15
	sta set_prg_bits_lo+1
	;c=1	
	adc #(v1_adsr_program_pos-pattern_command_instrument_direct_bits-1)
	sta set_prg_pos_lo+1
	adc #(v1_adsr_program_hold_timer-v1_adsr_program_pos)
	sta set_prg_time_lo+1
	lda (zp_idx_lo),y
	iny
set_prg_pos_lo	sta v1_adsr_program_pos,x
	lda #0
set_prg_time_lo	sta v1_adsr_program_hold_timer,x

set_prg_bits_lo	lda pattern_command_instrument_direct_bits
	ora v1_program_init_flags,x 	
	sta v1_program_init_flags,x 
	bne get_next_pattern_cmd
		

		
pattern_command
	;in A: $e0-$ef
	;in C: 0
	adc #(<pattern_command_indirect)/2+32
	asl		
	sta cmd_branche+1
	;C=0
	lda (zp_idx_lo),y
cmd_branche	jmp (pattern_command_indirect)


gateon_exe
	lda v1_channel_and,x
	ora #$01
	bne +
gateoff_exe
	;A=note
	lda v1_channel_and,x
	and #$fe
+	sta v1_channel_and,x
	bcc keep_current_note
	
	
speed_exe
	sta v1_pattern_speed_pos,x
	bcc inc_next_pattern_cmd
	
tie_exe
	adc v1_pattern_transpose,x
	sta v1_note_buffer,x	;if freq prg is not running (will be overwritten if it IS running)
	sta v1_note_base,x
	jmp keep_current_note

glito_exe
	ora #$80
	sta v1_porta_lfo_depth,x
	iny
	lda (zp_idx_lo),y
	adc v1_pattern_transpose,x	
	sta v1_note_target,x	;glito note
	sec		;20 $ff
	sbc v1_note_base,x
	sta v1_porta_lfo_length,x	;needs to be $01 or $ff
	jmp keep_current_note

glido_exe	
	sec
gliup_exe
	ora #$80
	sta v1_porta_lfo_depth,x
	ror
	sta v1_porta_lfo_length,x
	lda v1_program_init_flags,x	
	ora #%01000000		;dont use instrument porta prg	
	sta v1_program_init_flags,x 
inc_next_pattern_cmd	
	iny
	jmp get_next_pattern_cmd	
		


			
;======================================

	
;======================	
	;hard init
		;from pattern cmd
		;no hr
		;from instrument
	;instrument init
	;hard first frame
		;adsr exe
	;adsr exe
hard_restart_init
	
	lsr v1_program_init_flags,x

	lda v1_hard_program_pos,x
	
	inc v1_hard_restart_timer,x	;0->1 from pattern direct, $ff=>0 from instrument
	bne get_hard_restart_from_pattern_direct

	inc v1_hard_restart_timer,x

	bcc get_hard_restart_from_instrument
	
no_hard_restart_init		
	lda #0
	sta v1_hard_program_pos,x
	jmp osc_program_exe

		
get_hard_restart_from_instrument
			
	ldy v1_instrument,x

	lda instruments+6,y	
	sta v1_hard_program_pos,x

get_hard_restart_from_pattern_direct	
	anc #$9f
	tay
	bcs get_hard_restart_from_tables
	beq skip_hard_restart_from_tables

	
get_hard_restart_from_tables	
	
	
	lda hard_table_sr,y
	sta v1_sr,x
	lda hard_table_ad,y
	sta v1_ad,x
	lda hard_table_1st_frame,y
	sta v1_1st_frame,x
	
	lda v1_channel_and,x
	and #$fe
	sta v1_channel_and,x

	lda #0
skip_hard_restart_from_tables	
	jmp clear_freq_buffer
	

	
	
	

		
;=========

instrument_programs_init

;	ldy v1_instrument,x
			
	lsr v1_program_init_flags,x
	bcs check_pattern_osc_cmd
	
	lda instruments,y
	beq check_pattern_osc_cmd
	sta v1_adsr_program_pos,x
	lda #0
	sta v1_adsr_program_hold_timer,x
	
check_pattern_osc_cmd
	lsr v1_program_init_flags,x
	bcs check_pattern_freq_cmd
	
	lda instruments+2,y
	beq check_pattern_freq_cmd
	sta v1_osc_program_pos,x
	lda #0
	sta v1_osc_program_hold_timer,x

check_pattern_freq_cmd
	lsr v1_program_init_flags,x
	bcs check_pattern_pw_cmd
	
	lda instruments+3,y
	beq check_pattern_pw_cmd
	
	sta v1_freq_program_pos,x
	lda #0
	sta v1_freq_program_hold_timer,x
	sta v1_fine_tune,x
		
check_pattern_pw_cmd
	lsr v1_program_init_flags,x
	bcs check_pattern_filter_cmd

	lda instruments+4,y
	beq check_pattern_filter_cmd
	
	sta v1_pw_program_pos,x
		
	lda #0
	sta v1_pw_lfo_length,x
	
check_pattern_filter_cmd
	lsr v1_program_init_flags,x
	bcs check_pattern_porta_cmd
		
	lda instruments+5,y
	beq check_pattern_porta_cmd
	
	sta v1_filter_program_pos,x
	
	lda v1_filter_volume,x
	bne check_pattern_porta_cmd
	
	sta v1_filter_lfo_length,x
	
check_pattern_porta_cmd
	lsr v1_program_init_flags,x
	bcs osc_program_exe

	lda instruments+1,y
	sta v1_porta_program_pos,x

	lda #0
	jmp clear_porta_lfo
			
	
;==============================
hard_program_exe
	
	lda v1_hard_restart_timer,x
	bmi adsr_program_exe

	dec v1_hard_restart_timer,x
	bpl instrument_programs_init
	
	lda v1_hard_program_pos,x
	beq adsr_program_exe
	;bpl +
	;$c0 from instrument 0
	;sta v1_osc_buffer,x
	;+
	lda v1_channel_and,x
	ora #1
	sta v1_channel_and,x
	
	and v1_1st_frame,x
	jmp set_only_oscillator_direct
		

	
;=======ADSR=======================
		
adsr_program_exe
	
	ldy v1_adsr_program_pos,x
get_next_adsr	
	lda adsr_table_cmd,y
	beq osc_program_exe
	eor #$ff
	asl
	adc #<adsr_jump_table_indirect
	sta adsr_cmd_branche+1
	
	lda adsr_table_value,y
adsr_cmd_branche
	jmp (adsr_jump_table_indirect)	
set_ad_value	
	sta v1_ad,x
	iny
	bcc get_next_adsr
reset_sr_value
set_sr_value	
	sta v1_sr,x
	bcc adsr_program_exit-1
-	
	sta v1_adsr_program_hold_timer,x
	bcc adsr_program_exit
	 
adsr_wait
	beq adsr_program_exit-1
	cmp v1_adsr_program_hold_timer,x
	bcc -
	
adsr_wait_timer_running
	
	dec v1_adsr_program_hold_timer,x
	bne osc_program_exe
	
	iny
adsr_program_exit
	
	tya
adsr_loop
adsr_repeat
	sta v1_adsr_program_pos,x


	
;================oscillator program=========================


	
osc_program_exe
		
	ldy v1_osc_program_pos,x
	beq freq_program_exe
loop_osc_callback
	lda osc_table_cmd,y
	bpl osc_value	;no cmd, so has to be value
	eor #$ff
	asl
	adc #<osc_jump_table_indirect
	sta osc_cmd_branche+1


set_osc_program_value	
	lda osc_table_value,y
osc_cmd_branche
	jmp (osc_jump_table_indirect)
	
osc_value
	lda osc_table_value,y
	sta v1_osc_buffer,x
	iny
	bne osc_program_exit
osc_loop
	cmp v1_osc_program_pos,x
	beq freq_program_exe
	tay
	bne loop_osc_callback
-	
	sta v1_osc_program_hold_timer,x
	bcc osc_program_exit
		
osc_wait	
	beq osc_program_exit-1
	cmp v1_osc_program_hold_timer,x
	bcc -
	
	
osc_wait_timer_running
	
	dec v1_osc_program_hold_timer,x
	bne freq_program_exe
	
	iny
	
osc_program_exit
	tya
	sta v1_osc_program_pos,x

			
;================frequency program=========================

	
freq_program_exe
	ldy v1_freq_program_pos,x
	beq pw_program_exe
freq_loop_callback

	lda freq_table_cmd,y
	bpl freq_value
	eor #$ff
	asl
	adc #<freq_jump_table_indirect
	sta freq_cmd_branche+1

set_freq_program_value	
	lda freq_table_value,y
freq_cmd_branche
	jmp (freq_jump_table_indirect)

freq_value
	lda freq_table_value,y
	bmi absolute_freq
	cmp #$60	
	bcc positive_freq
	adc #$7f
positive_freq		
	adc v1_note_base,x
	
absolute_freq
	anc #$7f
	sta v1_note_buffer,x
	bcc freq_program_exit-1
freq_fine
	sta v1_fine_tune,x
	bcc freq_program_exit-1
freq_loop
	cmp v1_freq_program_pos,x
	beq pw_program_exe	;no infinite loop

	tay
	bne freq_loop_callback
-
	sta v1_freq_program_hold_timer,x
	bcc freq_program_exit
		
freq_wait
	beq freq_program_exit-1
	cmp v1_freq_program_hold_timer,x
	bcc -
	
	
freq_wait_timer_running
	
	dec v1_freq_program_hold_timer,x
	bne pw_program_exe
	iny
		
freq_program_exit
	tya
	sta v1_freq_program_pos,x	

	
	
	
;===============================================================
	


pw_program_exe
	
	lda v1_pw_lfo_length,x	
	asl		;set/clear carry for positive/negative pw
	beq pw_lfo_next_value

pw_lfo_running	
	dec v1_pw_lfo_length,x

	ldy v1_pw_lfo_depth,x
	beq filter_program_exe	
	;c=1 negative
	;c=0 positive
	php
	cpy #96
	lda #0
	bcc +
	lda pw_lookup_lo-96,y
+
	plp
	bcc positive_pw_1
	eor #$ff
positive_pw_1	
	sta zp_idx_hi
	
	lda pw_lookup_lo,y
	bcc positive_pw_2
	eor #$ff
positive_pw_2		
	adc v1_pw_lo_buffer,x
	sta v1_pw_lo_buffer,x
	sta v1_pw_lo,x

	lda zp_idx_hi
	adc v1_pw_hi_buffer,x	
	sta v1_pw_hi_buffer,x
	sta v1_pw_hi,x
	jmp filter_program_exe
	
	
	
pw_lfo_next_value

	ldy v1_pw_program_pos,x
	beq filter_program_exe
loop_pw_callback	
	lda pw_table_cmd,y
	bpl pw_value
	eor #$ff
	asl
	adc #<pw_jump_table_indirect
	sta pw_cmd_branche+1
	
	lda pw_table_value,y
pw_cmd_branche
	jmp (pw_jump_table_indirect)
	
pw_value
	sta v1_pw_hi_buffer,x
	sta v1_pw_hi,x

	lda pw_table_value,y
	sta v1_pw_lo_buffer,x
	sta v1_pw_lo,x
	jmp pw_program_exit
	
pw_route
pw_depth
	anc #$7f
	sta v1_pw_lfo_depth,x
	iny
	bcc loop_pw_callback

pw_down
	ora #$80
pw_up	
	sta v1_pw_lfo_length,x
	
pw_program_exit	
	iny
	tya
pw_loop
	sta v1_pw_program_pos,x	
	
		

	
;===============================================================
	
		
filter_program_exe
	.if FILTER_ACTIVE
	
	lda v1_filter_lfo_length,x
	asl
	beq filter_lfo_next_value

	
filter_lfo_running
	
	dec v1_filter_lfo_length,x

	lda v1_filter_volume,x
	bne filter_volume_lfo_running

	lda v1_filter_lfo_depth,x
	bcc positive_filter
	
	eor #$ff
positive_filter
	adc filter_hi+1
	sta filter_hi+1
	jmp porta_program_exe 
	
	

filter_volume_lfo_running
	ldy song_volume+1
	bcc positive_volume

	sbc v1_filter_lfo_depth,x
	bcs set_volume_value_lo
	dey	
	bcc set_volume_value_hi
		
positive_volume	
	adc v1_filter_lfo_depth,x
	bcc set_volume_value_lo
	iny	
set_volume_value_hi	
	cpy #$10
	bcs porta_program_exe
	sty song_volume+1
set_volume_value_lo
	ora #1
	sta v1_filter_volume,x
	bne porta_program_exe	
	

			
filter_lfo_next_value
		
	ldy v1_filter_program_pos,x		
	beq porta_program_exe
	
loop_filter_callback
	lda filter_table_cmd,y
	bpl init_new_filter_values
		
init_new_filter_cmd
	eor #$ff
	asl
	adc #<filter_jump_table_indirect
	sta filter_cmd_branche+1			
	
	lda filter_table_value,y
filter_cmd_branche
	jmp (filter_jump_table_indirect)
	

init_new_filter_values
	
	asl
	beq filter_value
	asl
	asl
	asl
	sta filter_mo+1
	
	lda filter_table_value,y
	sta filter_rs_ch+1
	iny 
	bne loop_filter_callback


filter_volume
	and #$0f
	sta song_volume+1
	lda #1
	bpl set_filter_volume

filter_value
	
	lda filter_table_value,y
	sta filter_hi+1
	lda #0
set_filter_volume	
	sta v1_filter_volume,x
	bpl filter_program_exit	
		
filter_depth
	sta v1_filter_lfo_depth,x
	iny
	bcc loop_filter_callback

filter_down
	ora #$80
filter_up	
	sta v1_filter_lfo_length,x
filter_program_exit	
	iny
	tya
filter_loop	
	sta v1_filter_program_pos,x	
	
	.fi
			
;================portamento program=========================
	
	
porta_program_exe
	
	
	lda v1_porta_lfo_length,x
	asl
	beq porta_lfo_next_value

porta_lfo_running
	lda v1_porta_lfo_depth,x
	bmi porta_lfo_endless_running	;for glide commands
	dec v1_porta_lfo_length,x

porta_lfo_endless_running	
	and #$7f
	beq porta_program_set_values
	
	php	;c=1/c=0
	
	clc	;needs to be cleared, else vibo will not equalize
	adc v1_note_base,x	
	tay
	cpy #96
	lda #0
	bcc +
	lda freq_table_hi-96,y
+
	plp
	bcc positive_porta_1
	eor #$ff
positive_porta_1
	sta zp_idx_hi

	lda freq_table_hi,y
	bcc positive_porta_2
	
	eor #$ff
positive_porta_2	
	adc v1_freq_lo_buffer,x
	sta v1_freq_lo_buffer,x
	
	lda v1_freq_hi_buffer,x
	adc zp_idx_hi
	sta v1_freq_hi_buffer,x
	jmp porta_program_set_values

	
	
		
porta_lfo_next_value
	ldy v1_porta_program_pos,x
	beq porta_program_set_values
loop_porta_callback
	lda porta_table_cmd,y
	bpl porta_program_set_values
	
	eor #$ff
	asl
	adc #<porta_jump_table_indirect
	sta porta_cmd_branche+1
	
	lda porta_table_value,y
porta_cmd_branche
	jmp (porta_jump_table_indirect)
	
porta_loop
	cmp v1_porta_program_pos,x
	beq porta_program_set_values
	tay
	bne loop_porta_callback

porta_depth
	anc #$7f
	sta v1_porta_lfo_depth,x
	iny
	bcc loop_porta_callback

porta_down
	ora #$80
porta_up	
	sta v1_porta_lfo_length,x
	iny
porta_program_exit

	tya
	sta v1_porta_program_pos,x	
	

	

;porta_route
;	iny
;	sty zp_idx_lo
;	tay
;	lda $d400,y
;	sta $0401,x
;	and #$7f
	
;	tay
;	lda pw_lookup_hi,y
;	sta v1_freq_hi_buffer,x
;	lda pw_lookup_lo,y
;	sta v1_freq_lo_buffer,x
;	ldy zp_idx_lo
;	jmp porta_program_exit
;porta_repeat
;	cmp v1_porta_program_repeat,x
;	bcs porta_repeat_running
;	
;	sta v1_porta_program_repeat,x
;	bcc porta_new_repeat
;porta_repeat_running		
;	dec v1_porta_program_repeat,x
;	bpl porta_new_repeat
;	iny
;porta_new_repeat		
;	iny
;	bne loop_porta_callback 


;=====================================
	
pattern_list_stop	
porta_program_set_values
check_for_glide
		
	ldy v1_note_target,x
	beq set_calculated_note
	
get_calculated_note		
	lda freq_table_lo,y
	sec
	sbc v1_freq_lo_buffer,x
	sta zp_idx_lo
	
	lda freq_table_hi,y
	sbc v1_freq_hi_buffer,x
	sta zp_idx_hi
	
	
	ldy v1_note_base,x
	
	lda freq_table_lo,y
	cmp zp_idx_lo
	lda freq_table_hi,y
	sbc zp_idx_hi
			
	arr #$80		
			
	eor v1_porta_lfo_length,x	
	bpl set_calculated_note
	

reset_base_note_after_glide
	ldy v1_instrument,x
	lda instruments+1,y
	sta v1_porta_program_pos,x
	
	
	lda v1_note_target,x
	sta v1_note_base,x
	sta v1_note_buffer,x
	
	
	lda #0
	sta v1_note_target,x
clear_porta_lfo		
	sta v1_porta_lfo_length,x
clear_freq_buffer	
	sta v1_freq_lo_buffer,x
	sta v1_freq_hi_buffer,x
	beq set_only_oscillator

		
set_calculated_note
	.if FINETUNE_ACTIVE

calculate_finetune
	lda v1_fine_tune,x
	beq set_calculated_note_values
	
	cmp #$80		
	php		
	bcc +	
	eor #$ff		
+	adc v1_note_base,x
	tay
	cpy #96
	
	lda #0	
	bcc +	
	lda freq_table_hi-96,y
+	plp
	bcc +
	eor #$ff
+	sta zp_idx_hi
	lda freq_table_hi,y	
	bcc +
	eor #$ff
+	.byte $0c
	
set_calculated_note_values
	sta zp_idx_hi
	sta zp_idx_lo
	
	ldy v1_note_buffer,x
	lda freq_table_lo,y
	clc
	adc v1_freq_lo_buffer,x
	bcc +
	inc zp_idx_hi
	clc	
+	adc zp_idx_lo
	sta v1_fq_lo,x
	
	lda freq_table_hi,y
	adc v1_freq_hi_buffer,x
	clc
	adc zp_idx_hi
	sta v1_fq_hi,x

	.else
	
	ldy v1_note_buffer,x
	lda freq_table_lo,y
	clc
	adc v1_freq_lo_buffer,x
	sta v1_fq_lo,x
	
	lda freq_table_hi,y
	adc v1_freq_hi_buffer,x
	sta v1_fq_hi,x
	
	.fi
		
	
	
set_only_oscillator
	lda v1_osc_buffer,x
	and v1_channel_and,x
set_only_oscillator_direct	
	sta v1_wf,x
	
	
;======================
pattern_speed_exe
	lda v1_pattern_speed_timer,x
	bne continue_pattern_speed
	
	ldy v1_pattern_speed_pos,x
	bne +
	ldy v123_current_song
	lda song_pattern_settings+3,y
	anc #$0f
	bcc default_pattern_speed	
+	
	lda rhythm_speeds,y
	bpl new_pattern_speed
	
	and #$7f
	sta v1_pattern_speed_pos,x
	
	tay
	lda rhythm_speeds,y
		
new_pattern_speed
	inc v1_pattern_speed_pos,x 
default_pattern_speed	
	sta v1_pattern_speed_timer,x
	
	
continue_pattern_speed	


	txa
	sbx #$07
	bmi exit_play_routine
multi_play_loop	jmp pattern_list_init	
	

	
;==========================================	

exit_play_routine
	
	.if FILTER_ACTIVE
	
filter_hi	lda #$00
	sta fi_fq_hi
	eor #$07	;some inversion for 8580
	;lda #7
	sta fi_fq_lo

filter_rs_ch	lda #$00
	sta fi_rs_ch
	
song_volume	lda #$0f
filter_mo	ora #$00
	sta fi_mo_vo
	
	.else
	
song_volume	lda #$0f
filter_mo	ora #$00
	sta fi_mo_vo
filter_rs_ch	lda #$00
	sta fi_rs_ch	
	.fi
	rts
	
music_routine_end
	
;pw_lookup_hi

pw_lookup_lo 
	
freq_table_hi
	;      B   C   C#  D   D#  E   F   F#  G   G#  A   A#  B
	.byte $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01  ; 0
                .byte $02,$02,$02,$02,$02,$02,$02,$03,$03,$03,$03,$03  ; 1
                .byte $04,$04,$04,$04,$05,$05,$05,$06,$06,$06,$07,$07  ; 2
                .byte $08,$08,$09,$09,$0a,$0a,$0b,$0c,$0d,$0d,$0e,$0f  ; 3
                .byte $10,$11,$12,$13,$14,$15,$17,$18,$1a,$1b,$1d,$1f  ; 4
                .byte $20,$22,$24,$27,$29,$2b,$2e,$31,$34,$37,$3a,$3e  ; 5
                .byte $41,$45,$49,$4e,$52,$57,$5c,$62,$68,$6e,$75,$7c  ; 6
	.byte $83,$8b,$93,$9c,$a5,$af,$b9,$c4,$d0,$dd,$ea,$f8  ; 7
freq_table_lo
	;      B   C   C#  D   D#  E   F   F#  G   G#  A   A#  B
                .byte $07,$17,$27,$39,$4b,$5f,$74,$8a,$a1,$ba,$d4,$f0  ; 0
                .byte $0e,$2d,$4e,$71,$96,$be,$e8,$14,$43,$74,$a9,$e1  ; 1
                .byte $1c,$5a,$9c,$e2,$2d,$7c,$cf,$28,$85,$e8,$52,$c1  ; 2
                .byte $37,$b4,$39,$c5,$5a,$f7,$9e,$4f,$0a,$d1,$a3,$82  ; 3
                .byte $6e,$68,$71,$8a,$b3,$ee,$3c,$9e,$15,$a2,$46,$04  ; 4
                .byte $dc,$d0,$e2,$14,$67,$dd,$79,$3c,$29,$44,$8d,$08  ; 5
                .byte $b8,$a1,$c5,$28,$cd,$ba,$f1,$78,$53,$87,$1a,$10  ; 6
                .byte $71,$42,$89,$4f,$9b,$74,$e2,$f0,$a6,$0e,$33,$20  ; 7
                
           

music_routine_end_incl_freq

	
	*=$1100
project_file_start
	
song_names
	.enc screen
	.TEXT "sONG 0          "
	.TEXT "sONG 1          "
	.TEXT "sONG 2          "
	.TEXT "sONG 3          "
	.TEXT "sONG 4          "
	.TEXT "sONG 5          "
	.TEXT "sONG 6          "
	.TEXT "sONG 7          "
	.TEXT "sONG 8          "
	.TEXT "sONG 9          "
	.TEXT "sONG a          "
	.TEXT "sONG b          "
	.TEXT "sONG c          "
	.TEXT "sONG d          "
	.TEXT "sONG e          "
	
	;*=$11F0
	
	.TEXT "fREE PLAY MODE  "
	.enc none
		
	*=$1200
	
instrument_data_start	
instrument_names
project_header
	.text "VIRTUOSO ",((>version_number)>>4)|$30,".",((>version_number)&15)|$30,((<version_number)>>4)|$30
project_pattern_length	
	.byte 0
	.byte 0,0
	.enc screen			
instrument_names_copy_start	
	.text "iNSTRUMENT 01   "
	.text "iNSTRUMENT 02   "
	.text "iNSTRUMENT 03   "
	.text "iNSTRUMENT 04   "
	.text "iNSTRUMENT 05   "
	.text "iNSTRUMENT 06   "
	.text "iNSTRUMENT 07   "
	.text "iNSTRUMENT 08   "
	.text "iNSTRUMENT 09   "
	.text "iNSTRUMENT 0a   "
	.text "iNSTRUMENT 0b   "
	.text "iNSTRUMENT 0c   "
	.text "iNSTRUMENT 0d   "
	.text "iNSTRUMENT 0e   "
	.text "iNSTRUMENT 0f   "
	.text "iNSTRUMENT 10   "
	.text "iNSTRUMENT 11   "
	.text "iNSTRUMENT 12   "
	.text "iNSTRUMENT 13   "
	.text "iNSTRUMENT 14   "
	.text "iNSTRUMENT 15   "
	.text "iNSTRUMENT 16   "
	.text "iNSTRUMENT 17   "
	.text "iNSTRUMENT 18   "
	.text "iNSTRUMENT 19   "
	.text "iNSTRUMENT 1a   "
	.text "iNSTRUMENT 1b   "
	.text "iNSTRUMENT 1c   "
	.text "iNSTRUMENT 1d   "
	.text "iNSTRUMENT 1e   "
	.text "iNSTRUMENT 1f   "
	.enc none	
		
	*=$1400
music_data_start	
instruments
i00_clear
	.byte (prg_adsr00-adsr_table_cmd)
	.byte (prg_porta00-porta_table_cmd)
	.byte (prg_osc00-osc_table_cmd)
	.byte (prg_freq00-freq_table_cmd)
	.byte (prg_pw00-pw_table_cmd)
	.byte (prg_filter00-filter_table_cmd)
	.byte $80
	.byte 0
i01_bass	;bass
;	.byte (prg_adsr01-adsr_table_cmd)
;	.byte (prg_porta01-porta_table_cmd)
;	.byte (prg_osc01-osc_table_cmd)
;	.byte (prg_freq01-freq_table_cmd)
;	.byte (prg_pw01-pw_table_cmd)
;	.byte (prg_filter01-filter_table_cmd)
;	.byte (prg_hard01_ad-hard_table_ad)
;	.byte 0
i02_snare	;snare
;	.byte (prg_adsr02-adsr_table_cmd)
;	.byte (prg_porta00-porta_table_cmd)
;	.byte (prg_osc02-osc_table_cmd)
;	.byte (prg_freq02-freq_table_cmd)
;	.byte (prg_pw02-pw_table_cmd)
;	.byte (prg_filter02-filter_table_cmd)
;	.byte (prg_hard01_ad-hard_table_ad)
;	.byte 0
i03_base	;base
;	.byte (prg_adsr03-adsr_table_cmd)
;	.byte (prg_porta00-porta_table_cmd)
;	.byte (prg_osc03-osc_table_cmd)
;	.byte (prg_freq03-freq_table_cmd)
;	.byte (prg_pw03-pw_table_cmd)
;	.byte (prg_filter00-filter_table_cmd)
;	.byte (prg_hard01_ad-hard_table_ad)
;	.byte 0	
i04_short	;short
;	.byte (prg_adsr04-adsr_table_cmd)
;	.byte (prg_porta00-porta_table_cmd)
;	.byte (prg_osc04-osc_table_cmd)
;	.byte (prg_freq04-freq_table_cmd)
;	.byte (prg_pw04-pw_table_cmd)
;	.byte (prg_filter00-filter_table_cmd)
;	.byte (prg_hard01_ad-hard_table_ad)
;	.byte 0		
i05_shortarp	;short arp
;	.byte (prg_adsr04-adsr_table_cmd)
;	.byte (prg_porta00-porta_table_cmd)
;	.byte (prg_osc04-osc_table_cmd)
;	.byte (prg_freq05-freq_table_cmd)
;	.byte (prg_pw04-pw_table_cmd)
;	.byte (prg_filter00-filter_table_cmd)
;	.byte (prg_hard01_ad-hard_table_ad)
;	.byte 0	
i06_melody	;melody
;	.byte (prg_adsr06-adsr_table_cmd)
;	.byte (prg_porta06-porta_table_cmd)
;	.byte (prg_osc06-osc_table_cmd+3)
;	.byte (prg_freq06-freq_table_cmd)
;	.byte (prg_pw06-pw_table_cmd)
;	.byte (prg_filter00-filter_table_cmd)
;	.byte 0;(prg_hard01_ad-hard_table_ad)
;	.byte 0
i07_hihat	;hi hat
;	.byte (prg_adsr07-adsr_table_cmd)
;	.byte (prg_porta06-porta_table_cmd)
;	.byte (prg_osc07-osc_table_cmd)
;	.byte (prg_freq07-freq_table_cmd)
;	.byte (prg_pw02-pw_table_cmd)
;	.byte (prg_filter00-filter_table_cmd)
;	.byte (prg_hard01_ad-hard_table_ad)
;	.byte 0
i08_melody_hard
;	.byte (prg_adsr06-adsr_table_cmd)
;	.byte (prg_porta06-porta_table_cmd)
;	.byte 2
;	.byte (prg_freq06-freq_table_cmd+1)
;	.byte (prg_pw06-pw_table_cmd)
;	.byte (prg_filter00-filter_table_cmd)
;	.byte 0
;	.byte 0
	
	
	*=$1500
instrument_tables	
adsr_table_cmd
prg_adsr00	.byte stop
;prg_adsr01	.byte setad,setsr,stop
;prg_adsr02	.byte setad,setsr,wait,setsr,stop
;prg_adsr03	.byte setad,setsr,stop
;prg_adsr04	.byte setad,setsr,stop
;prg_adsr06	.byte setad,setsr,stop
;prg_adsr07	.byte setad,setsr,stop
;prg_adsr08	.byte setad,setsr,stop

	*=$1600
adsr_table_value
prg_adsr00_v	.byte stop
;prg_adsr01_v	.byte $00,$cc,stop
;prg_adsr02_v	.byte $00,$e7,$00,$76,stop
;prg_adsr03_v	.byte $00,$f8,stop
;prg_adsr04_v	.byte $00,$79,stop
;prg_adsr06_v	.byte $00,$7b,stop
;prg_adsr07_v	.byte $00,$4c,stop
;prg_adsr08_v	.byte $00,$74,stop

	*=$1700
porta_table_cmd
prg_porta00	.byte stop
;prg_porta01	.byte depth,down,depth,up,down,up,loop
;prg_porta06	.byte depth,up,depth,up,down,up,loop

	*=$1800
porta_table_value	 
prg_porta00_v	.byte stop 
;prg_porta01_v	.byte $00,$08,$18,$02,$04,$02,(prg_porta01-porta_table_cmd+3)
;prg_porta06_v	.byte $00,$20,$24,$02,$04,$02,(prg_porta06-porta_table_cmd+3)

	*=$1900	
osc_table_cmd
prg_osc00	.byte stop
;prg_osc01	.byte $00,$00,stop
;prg_osc02	.byte $00,$00,$00,$00,stop
;prg_osc03	.byte $00,$00,$00,$00,stop
;prg_osc04	.byte $00,$00,$00,stop
;prg_osc06	.byte $00,$00,$00,$00,wait,$00,stop
;prg_osc07	.byte $00,$00,stop

	*=$1a00
osc_table_value
prg_osc00_v	.byte stop
;prg_osc01_v	.byte $81,$41,stop
;prg_osc02_v	.byte $81,$41,$41,$80,stop
;prg_osc03_v	.byte $81,$41,$40,$10,stop
;prg_osc04_v	.byte $41,$41,$40,stop
;prg_osc06_v	.byte $41,$21,$21,$41,$30,$47,stop
;prg_osc07_v	.byte $21,$27,stop

	*=$1b00
freq_table_cmd
prg_freq00	.byte stop
;prg_freq01	.byte $00,$00,stop
;prg_freq02	.byte $00,$00,$00,$00,$00,stop
;prg_freq03	.byte $00,$00,$00,$00,$00,$00,stop
;prg_freq04	.byte $00,$00,stop
;prg_freq05	.byte $00,$00,$00,$00,$00,$00,loop
;prg_freq06	.byte finetune,$00,$00,$00,stop
;prg_freq07	.byte $00,stop

	*=$1c00
freq_table_value
prg_freq00_v	.byte stop
;prg_freq01_v	.byte $de,$00,stop
;prg_freq02_v	.byte $df,$ad,$a9,$d8,$b8,stop
;prg_freq03_v	.byte $d0,$a6,$a0,$9c,$98,$90,stop
;prg_freq04_v	.byte $0c,$00,stop
;prg_freq05_v	.byte $0c,$00,$0a,$05,$09,$02,(prg_freq05-freq_table_cmd+1)
;prg_freq06_v	.byte $02,$00,$0c,$00,stop
;prg_freq07_v	.byte $0c,stop

	*=$1d00
pw_table_cmd
prg_pw00	.byte stop
;prg_pw01	.byte $06,depth,up,$08,depth,up,depth,up,down,loop
;prg_pw02	.byte $07,stop
;prg_pw03	.byte $07,stop
;prg_pw04	.byte depth,up,loop
;prg_pw06	.byte $08,depth,up,$0e,depth,down,up,loop

	*=$1e00
pw_table_value
prg_pw00_v	.byte stop
;prg_pw01_v	.byte $80,$00,$04,$00,$24,$10,$42,$18,$18,(prg_pw01-pw_table_cmd+7)
;prg_pw02_v	.byte $80,stop
;prg_pw03_v	.byte $80,stop
;prg_pw04_v	.byte $0f,$01,(prg_pw04-pw_table_cmd+1)
;prg_pw06_v	.byte $00,$30,$10,$00,$38,$09,$08,(prg_pw06-pw_table_cmd+5)

	*=$1f00
filter_table_cmd
prg_filter00	.byte stop
;prg_filter01	.byte $01,$00,$03,$00,$00,$00,depth,down,depth,down,stop
;prg_filter02	.byte $03,$00,depth,down,$01,$00,stop
;prg_filter03	.byte volume,depth,down,up,loop

	*=$2000
filter_table_value
prg_filter00_v	.byte stop
;prg_filter01_v	.byte $02,$ff,$c2,$04,$30,$ff,$7f,$01,$70,$01,stop
;prg_filter02_v	.byte $02,$ff,$00,$01,$c2,$ff,stop
;prg_filter03_v	.byte $0f,$ff,$07,$07,(prg_filter03-filter_table_cmd+2)

	*=$2100
hard_table_1st_frame
prg_hard00_1st	.byte $09
;prg_hard01_1st	.byte $09

	*=$2120
hard_table_ad
prg_hard00_ad	.byte $ff
;prg_hard01_ad	.byte $ff

	*=$2140
hard_table_sr
prg_hard00_sr	.byte $ff
;prg_hard01_sr	.byte $f1
	;*=$2260
	;free

	*=$2180
free_play_layered_presets
	;instr,instr,instr,oct,oct,oct,multispeed,unused
	.byte $01,$01,$01,$01,$02,$03,$00,$00
	.byte $01,$01,$01,$01,$02,$03,$00,$00
	.byte $01,$01,$01,$01,$02,$03,$00,$00
	.byte $01,$01,$01,$01,$02,$03,$00,$00
	.byte $01,$01,$01,$01,$02,$03,$00,$00
	.byte $01,$01,$01,$01,$02,$03,$00,$00
	.byte $01,$01,$01,$01,$02,$03,$00,$00
	.byte $01,$01,$01,$01,$02,$03,$00,$00
	
	;*=$21c0
	;free
	
	*=$2200
instrument_data_end
	
rhythm_speeds
	.byte $81
;	.byte $04,$04,$03,$03,$81
;	.byte $07,$07,$86

		
	*=$2280
	
song_pattern_settings
	.byte <s0_v1_patterns,<s0_v2_patterns,<s0_v3_patterns,$06
	.byte <s1_v1_patterns,<s1_v2_patterns,<s1_v3_patterns,$06
	.byte <s2_v1_patterns,<s2_v2_patterns,<s2_v3_patterns,$06
	.byte <s3_v1_patterns,<s3_v2_patterns,<s3_v3_patterns,$06
	.byte <s4_v1_patterns,<s4_v2_patterns,<s4_v3_patterns,$06
	.byte <s5_v1_patterns,<s5_v2_patterns,<s5_v3_patterns,$06
	.byte <s6_v1_patterns,<s6_v2_patterns,<s6_v3_patterns,$06
	.byte <s7_v1_patterns,<s7_v2_patterns,<s7_v3_patterns,$06
	.byte <s8_v1_patterns,<s8_v2_patterns,<s8_v3_patterns,$06
	.byte <s9_v1_patterns,<s9_v2_patterns,<s9_v3_patterns,$06
	.byte <sa_v1_patterns,<sa_v2_patterns,<sa_v3_patterns,$06
	.byte <sb_v1_patterns,<sb_v2_patterns,<sb_v3_patterns,$06
	.byte <sc_v1_patterns,<sc_v2_patterns,<sc_v3_patterns,$06
	.byte <sd_v1_patterns,<sd_v2_patterns,<sd_v3_patterns,$06
	.byte <se_v1_patterns,<se_v2_patterns,<se_v3_patterns,$06
song_pattern_settings_free_play	
	.byte <free_play_v1_patterns,<free_play_v2_patterns,<free_play_v3_patterns,$00

	
		
	*=$2300
sequencer_data_start

s0_v1_patterns
	.byte 0,loop,0
;	.byte up00,6,dwn0c,6,up0c,6,up00,6,loop,0
s1_v1_patterns = s0_v1_patterns
;	.byte 7,loop,10
s2_v1_patterns = s0_v1_patterns
;	.byte stop
s3_v1_patterns = s0_v1_patterns
;	.byte stop
s4_v1_patterns = s0_v1_patterns
;	.byte stop
s5_v1_patterns = s0_v1_patterns
;	.byte stop
s6_v1_patterns = s0_v1_patterns
;	.byte stop
s7_v1_patterns = s0_v1_patterns
;	.byte stop
s8_v1_patterns = s0_v1_patterns
;	.byte stop
s9_v1_patterns = s0_v1_patterns
;	.byte stop
sa_v1_patterns = s0_v1_patterns
;	.byte stop
sb_v1_patterns = s0_v1_patterns
;	.byte stop
sc_v1_patterns = s0_v1_patterns
;	.byte stop
sd_v1_patterns = s0_v1_patterns
;	.byte stop
se_v1_patterns = s0_v1_patterns
	.fill (free_play_v1_patterns-s2_v1_patterns),end

	*=$23f8
free_play_v1_patterns
	.byte $50,end,end,end,end,end,end,end

	*=$2400
s0_v2_patterns
	.byte 1,loop,0
;	.byte up00,1,up0c,2,loop,0
s1_v2_patterns = s0_v2_patterns
;	.byte 7,loop,6
s2_v2_patterns = s0_v2_patterns
;	.byte stop
s3_v2_patterns = s0_v2_patterns
;	.byte stop
s4_v2_patterns = s0_v2_patterns
;	.byte stop
s5_v2_patterns = s0_v2_patterns
;	.byte stop
s6_v2_patterns = s0_v2_patterns
;	.byte stop
s7_v2_patterns = s0_v2_patterns
;	.byte stop
s8_v2_patterns = s0_v2_patterns
;	.byte stop
s9_v2_patterns = s0_v2_patterns
;	.byte stop
sa_v2_patterns = s0_v2_patterns
;	.byte stop
sb_v2_patterns = s0_v2_patterns
;	.byte stop
sc_v2_patterns = s0_v2_patterns
;	.byte stop
sd_v2_patterns = s0_v2_patterns
;	.byte stop
se_v2_patterns = s0_v2_patterns
	.fill (free_play_v2_patterns-s2_v2_patterns),end
	
	*=$24f8
free_play_v2_patterns
	.byte $51,end,end,end,end,end,end,end

	*=$2500
s0_v3_patterns
	.byte 2,loop,0
;	.byte rpt07,3,loop,0
s1_v3_patterns = s0_v3_patterns
;	.byte 7,loop,4
s2_v3_patterns = s0_v3_patterns
;	.byte stop
s3_v3_patterns = s0_v3_patterns
;	.byte stop
s4_v3_patterns = s0_v3_patterns
;	.byte stop
s5_v3_patterns = s0_v3_patterns
;	.byte stop
s6_v3_patterns = s0_v3_patterns
;	.byte stop
s7_v3_patterns = s0_v3_patterns
;	.byte stop
s8_v3_patterns = s0_v3_patterns
;	.byte stop
s9_v3_patterns = s0_v3_patterns
;	.byte stop
sa_v3_patterns = s0_v3_patterns
;	.byte stop
sb_v3_patterns = s0_v3_patterns
;	.byte stop
sc_v3_patterns = s0_v3_patterns
;	.byte stop
sd_v3_patterns = s0_v3_patterns
;	.byte stop
se_v3_patterns = s0_v3_patterns
;	.byte stop
	.fill (free_play_v3_patterns-s2_v3_patterns),end
	*=$25f8
free_play_v3_patterns
	.byte $52,end,end,end,end,end,end,end

sequencer_data_end
		
	*=$2600
song_patterns
	.word s0_v1_patterns,s0_v2_patterns,s0_v3_patterns

	*=$2620	
	
pattern_pointers_start	
patterns_lo
	.byte <pattern00,<pattern01,<pattern02,<pattern03,<pattern04,<pattern05,<pattern06,<pattern07
	.byte <pattern08,<pattern09,<pattern0a,<pattern0b,<pattern0c,<pattern0d,<pattern0e,<pattern0f
	.byte <pattern10,<pattern11,<pattern12,<pattern13,<pattern14,<pattern15,<pattern16,<pattern17
	.byte <pattern18,<pattern19,<pattern1a,<pattern1b,<pattern1c,<pattern1d,<pattern1e,<pattern1f
	.byte <pattern20,<pattern21,<pattern22,<pattern23,<pattern24,<pattern25,<pattern26,<pattern27
	.byte <pattern28,<pattern29,<pattern2a,<pattern2b,<pattern2c,<pattern2d,<pattern2e,<pattern2f
	.byte <pattern30,<pattern31,<pattern32,<pattern33,<pattern34,<pattern35,<pattern36,<pattern37
	.byte <pattern38,<pattern39,<pattern3a,<pattern3b,<pattern3c,<pattern3d,<pattern3e,<pattern3f
	.byte <pattern40,<pattern41,<pattern42,<pattern43,<pattern44,<pattern45,<pattern46,<pattern47
	.byte <pattern48,<pattern49,<pattern4a,<pattern4b,<pattern4c,<pattern4d,<pattern4e,<pattern4f
	.byte <pattern50,<pattern51,<pattern52
	
	*=$2680
patterns_hi
	.byte >pattern00,>pattern01,>pattern02,>pattern03,>pattern04,>pattern05,>pattern06,>pattern07
	.byte >pattern08,>pattern09,>pattern0a,>pattern0b,>pattern0c,>pattern0d,>pattern0e,>pattern0f
	.byte >pattern10,>pattern11,>pattern12,>pattern13,>pattern14,>pattern15,>pattern16,>pattern17
	.byte >pattern18,>pattern19,>pattern1a,>pattern1b,>pattern1c,>pattern1d,>pattern1e,>pattern1f
	.byte >pattern20,>pattern21,>pattern22,>pattern23,>pattern24,>pattern25,>pattern26,>pattern27
	.byte >pattern28,>pattern29,>pattern2a,>pattern2b,>pattern2c,>pattern2d,>pattern2e,>pattern2f
	.byte >pattern30,>pattern31,>pattern32,>pattern33,>pattern34,>pattern35,>pattern36,>pattern37
	.byte >pattern38,>pattern39,>pattern3a,>pattern3b,>pattern3c,>pattern3d,>pattern3e,>pattern3f
	.byte >pattern40,>pattern41,>pattern42,>pattern43,>pattern44,>pattern45,>pattern46,>pattern47
	.byte >pattern48,>pattern49,>pattern4a,>pattern4b,>pattern4c,>pattern4d,>pattern4e,>pattern4f
	.byte >pattern50,>pattern51,>pattern52
	
pattern_pointers_end
	
		

     	

	*=$2700
patterns	
pattern00	.byte dur3f,0,end;	.byte dur3f,0,end
	.align 256
pattern01	.byte dur3f,0,end;	.byte speed,1,dur01,ins01,ds1,gateon,nonote,a1,gateoff,nonote,ins02,ds3,ins01,a0,gateoff,nonote,c2,dur03,c2,dur01,c1,cs1,ins02,ds3,ins01,ds1,gateoff,nonote,e1,dur03,e1,dur01,as1,fs1,ins02,ds3,ins01,g1,dur05,as1,dur01,e2,gateoff,nonote,ds2,ins02,ds3,dur05,ins01,cs2,end
	.align 256
pattern02	.byte dur3f,0,end;	.byte speed,1,dur03,ins01,c1,dur01,as2,c2,dur03,ins02,c0,dur01,ins01,g1,g2,dur03,as1,dur01,as1,c2,dur03,ins02,c0,dur01,ins01,cs2,c1,dur07,ds2,dur01,ins02,c0,ins01,b2,ds3,cs3,b2,cs3,b1,b2,ins02,c0,dur03,ins01,glido,$33,fs3,dur01,as1,end   
	.align 256
pattern03	.byte dur3f,0,end;	.byte dur00,ins03,c0,ins04,as4,dur01,ins05,as3,dur00,ins04,as4,as3,ins05,as3,ins03,c0,end
	.align 256
pattern04	.byte dur3f,0,end;	.byte speed,1,dur01,ins06,as3,b3,c4,gateoff,nonote,cs5,dur00,gateoff,nonote,c5,dur01,gateoff,nonote,dur03,c5,dur01,fs4,b4,gateoff,nonote,gs4,as4,dur03,as4,fs4,dur01,f4,ds4,gateoff,nonote,cs5,gateoff,nonote,dur03,ds5,dur00,ds4,dur02,gateoff,nonote,dur00,ds4,dur02,gateoff,nonote,dur00,ds4,dur00,gateoff,nonote,dur01,e4,f4,end
	.align 256
pattern05	.byte dur3f,0,end;	.byte speed,1,dur0f,ins07,c5,gliup,$1f,nonote,dur1f,glido,$17,b5,end
	.align 256
pattern06	.byte dur3f,0,end;	.byte speed,1,dur07,ins06,as4,dur05,prgpul,1,glito,$10,c5,dur00,as4,gateoff,nonote,dur01,c5,gateon,nonote,dur01,fs4,prgpul,1,tie,g4,dur00,tie,as4,tie,g4,tie,f4,dur04,tie,fs4,dur0f,f4,dur07,ds4,glido,$1f,nonote,end
	.align 256
pattern07	.byte dur3f,0,end;	.byte speed,1,dur07,ins08,as4,dur05,glito,$10,c5,dur01,as4,dur03,c5,dur01,fs4,tie,g4,dur00,tie,as4,tie,g4,tie,f4,dur04,tie,fs4,dur0f,f4,dur07,ds4,glido,$10,nonote,end
	.align 256
pattern08	.byte dur3f,0,end
	.align 256
pattern09	.byte dur3f,0,end
	.align 256
pattern0a	.byte dur3f,0,end
	.align 256
pattern0b	.byte dur3f,0,end
	.align 256
pattern0c	.byte dur3f,0,end
	.align 256
pattern0d	.byte dur3f,0,end
	.align 256
pattern0e	.byte dur3f,0,end
	.align 256
pattern0f	.byte dur3f,0,end
	.align 256
pattern10	.byte dur3f,0,end
	.align 256
pattern11	.byte dur3f,0,end
	.align 256
pattern12	.byte dur3f,0,end
	.align 256
pattern13	.byte dur3f,0,end
	.align 256
pattern14	.byte dur3f,0,end
	.align 256
pattern15	.byte dur3f,0,end
	.align 256
pattern16	.byte dur3f,0,end
	.align 256
pattern17	.byte dur3f,0,end
	.align 256
pattern18	.byte dur3f,0,end
	.align 256
pattern19	.byte dur3f,0,end
	.align 256
pattern1a	.byte dur3f,0,end
	.align 256
pattern1b	.byte dur3f,0,end
	.align 256
pattern1c	.byte dur3f,0,end
	.align 256
pattern1d	.byte dur3f,0,end
	.align 256
pattern1e	.byte dur3f,0,end
	.align 256
pattern1f	.byte dur3f,0,end
	.align 256
pattern20	.byte dur3f,0,end
	.align 256
pattern21	.byte dur3f,0,end
	.align 256
pattern22	.byte dur3f,0,end
	.align 256
pattern23	.byte dur3f,0,end
	.align 256
pattern24	.byte dur3f,0,end
	.align 256
pattern25	.byte dur3f,0,end
	.align 256
pattern26	.byte dur3f,0,end
	.align 256
pattern27	.byte dur3f,0,end
	.align 256
pattern28	.byte dur3f,0,end
	.align 256
pattern29	.byte dur3f,0,end
	.align 256
pattern2a	.byte dur3f,0,end
	.align 256
pattern2b	.byte dur3f,0,end
	.align 256
pattern2c	.byte dur3f,0,end
	.align 256
pattern2d	.byte dur3f,0,end
	.align 256
pattern2e	.byte dur3f,0,end
	.align 256
pattern2f	.byte dur3f,0,end
	.align 256
pattern30	.byte dur3f,0,end
	.align 256
pattern31	.byte dur3f,0,end
	.align 256
pattern32	.byte dur3f,0,end
	.align 256
pattern33	.byte dur3f,0,end
	.align 256
pattern34	.byte dur3f,0,end
	.align 256
pattern35	.byte dur3f,0,end
	.align 256
pattern36	.byte dur3f,0,end
	.align 256
pattern37	.byte dur3f,0,end
	.align 256
pattern38	.byte dur3f,0,end
	.align 256
pattern39	.byte dur3f,0,end
	.align 256
pattern3a	.byte dur3f,0,end
	.align 256
pattern3b	.byte dur3f,0,end
	.align 256
pattern3c	.byte dur3f,0,end
	.align 256
pattern3d	.byte dur3f,0,end
	.align 256
pattern3e	.byte dur3f,0,end
	.align 256
pattern3f	.byte dur3f,0,end
	.align 256
pattern40	.byte dur3f,0,end
	.align 256
pattern41	.byte dur3f,0,end
	.align 256
pattern42	.byte dur3f,0,end
	.align 256
pattern43	.byte dur3f,0,end
	.align 256
pattern44	.byte dur3f,0,end
	.align 256
pattern45	.byte dur3f,0,end
	.align 256
pattern46	.byte dur3f,0,end
	.align 256
pattern47	.byte dur3f,0,end
	.align 256
pattern48	.byte dur3f,0,end
	.align 256
pattern49	.byte dur3f,0,end
	.align 256
pattern4a	.byte dur3f,0,end
	.align 256
pattern4b	.byte dur3f,0,end
	.align 256
pattern4c	.byte dur3f,0,end
	.align 256
pattern4d	.byte dur3f,0,end
	.align 256
pattern4e	.byte dur3f,0,end
	.align 256
pattern4f	.byte dur3f,0,end
	.align 256
music_data_end

free_play_patterns
	
pattern50
free_play_pattern00
	.byte dur3f,ins00,c0,end
	.align 16
pattern51
free_play_pattern01	
	.byte dur3f,ins00,c0,end
	.align 16
pattern52
free_play_pattern02
	.byte dur3f,ins00,c0,end

	
	