
make_copy_edit_window
	lda zp_ed_backup_screen
	beq ++
	lda #0
	sta zp_ed_backup_screen	
	ldx #143
-	
	ldy #23
-	
	
	lda $b400+(start_row*40)+7+40,x
	sta $e100+7+40,x

	lda $b400+(start_row*40)+7+200,x
	sta $e100+7+200,x
	
	lda $b400+(start_row*40)+7+360,x
	sta $e100+7+360,x

	lda $b400+(start_row*40)+7+520,x
	sta $e100+7+520,x

	cpx #120
	bcc +	
	lda $b400+(start_row*40)+7+680,y
	sta $e100+7+680,y
+	dex
	dey
	bpl -
	
	txa
	sbx #16
	bpl --
+
	rts
	
open_pattern_window_set_row
	lda screen_row_lo,x
	sta zp_ed_scr_to_lo+2
	sta zp_ed_scr_from_row+2	;$d800

	;-- not needed in clear top/bottom	
	clc
	adc current_pattern_cmd_column	;start_end_scroll_column,x
	sta zp_ed_scr_to_row+2
	sta zp_ed_scr_to_buffer+2	

	lda screen_row_hi,x
	sta zp_ed_scr_to_hi+2
	eor #$6c
	sta zp_ed_scr_from_row+3
	
	;-- not needed in clear top/bottom
	adc #0
	sta zp_ed_scr_to_buffer+3
	eor #$6c	
	sta zp_ed_scr_to_row+3
-
	rts	


open_edit_window
	ldx zp_ed_window_open_row
	beq -
	php
	
open_pattern_cmd_window
	
	
	jsr open_pattern_window_set_row
		
	dex
	dex
	dex
	lda screen_row_lo,x
	sta zp_ed_scr_from_lo+2	;setup backup location

	lda screen_row_hi,x	
	;clc
	adc #$2d
	sta zp_ed_scr_from_hi+2
	
	ldx zp_ed_window_open_row
	plp
	php
	bcs +

	cpx #4
	bcc +
			
	jsr copy_backup_open_window

+	
	lda open_arrow_char_row,x
	sta open_arrow_idx+1
		
	ldx #0
-	
	ldy #40
-
	lda #$ff
	sta zp_ed_scr_nybble_hi+2
	
	lda pattern_cmd_window,x
	bne open_arrow_check_1
	
	lda #$dd
	sta zp_ed_scr_nybble_hi+2
	sty zp_ed_scr_nybble_prehi+2
	stx zp_ed_channel_temp+2
	
	txa
	lsr
	tax
	ldy div3-1,x
	lda instrument_tables_max_length,y
	sta zp_ed_scr_temp+2		;remove possible hi-bits
	lda depack_pattern_command_page,y
	pha
	anc #$07
	sta zp_ed_scr_to_hi+2
	
	jsr convert_column_to_voice_x	
	jsr convert_voice_x_to_memory
	adc zp_ed_scr_to_hi+2
	sta zp_ed_scr_to_hi+2
	
	ldy pattern_memory_position,x

	jsr init_io_ram
			
	pla
	;check for glide command
	cmp #$81	;pattern glide command located at 0180
	beq check_for_glide_open_window
	
		
no_check_glide_open_window

	and #$80
	sta zp_ed_scr_to_lo+2
	
	lda (zp_ed_scr_to_lo+2),y
	and zp_ed_scr_temp+2
	
	
	jsr convert_byte_to_text_scr_in_irq
;	tya
check_glide_found_open_window
	
	ldy zp_ed_scr_nybble_prehi+2
	sta (zp_ed_scr_to_row+2),y
	jsr return_io
	
	ldx zp_ed_channel_temp+2
	
	lda zp_ed_scr_nybble_hi+2
	sta (zp_ed_scr_to_buffer+2),y
	
	iny
	inx	
		
	lda zp_ed_scr_nybble_lo+2

open_arrow_check_1
	bpl +
	inc zp_ed_scr_nybble_hi+2	;color $ff->$00
+	
open_arrow_idx	cpx #0
	bne +
	lda #$df	;arrow right	
+	sta (zp_ed_scr_to_row+2),y
	lda zp_ed_scr_nybble_hi+2
	sta (zp_ed_scr_to_buffer+2),y
	
	inx
	cpx #60
	bcs exit_open_cmd_window
	iny
	cpy #46
	bcc -
	
	lda zp_ed_scr_to_row+2
	adc #$27
	sta zp_ed_scr_to_row+2
	bcc +
	inc zp_ed_scr_to_row+3
	clc
+	lda zp_ed_scr_to_buffer+2
	adc #$28
	sta zp_ed_scr_to_buffer+2
	bcc +
	inc zp_ed_scr_to_buffer+3	
+	jmp --

check_for_glide_open_window
	tax
	dec zp_ed_scr_to_hi+2
	lda #0
	sta zp_ed_scr_to_lo+2
	lda (zp_ed_scr_to_lo+2),y
	and #%11100000
	beq +
	cmp #%10100000
	beq +
	lda #"-"
	sta zp_ed_glide_command	;temp boolean
	sta zp_ed_scr_nybble_lo+2
	bne check_glide_found_open_window
+	txa
	inc zp_ed_scr_to_hi+2
	bne no_check_glide_open_window
	
exit_open_cmd_window
	plp
	bcs copy_backup_open_window_exit
	
	lda zp_ed_scr_from_lo+2
	adc #$b8
	sta zp_ed_scr_from_lo+2
	
	lda zp_ed_scr_from_hi+2
	adc #$01
	sta zp_ed_scr_from_hi+2

		
	lax zp_ed_window_open_row
	sbx #$f5
	
	jsr open_pattern_window_set_row
	
	
	lda zp_ed_window_open_row
	cmp #10
	bcs copy_backup_open_window_exit
	
copy_backup_open_window
	
	ldy #30
-	
	lda (zp_ed_scr_from_lo+2),y
	sta (zp_ed_scr_to_lo+2),y
	cpy #30
	bcc +
	and #$80
	bmi ++
	
+	lda $d800+(start_row*40),y
+	sta (zp_ed_scr_from_row+2),y
	dey
	cpy #7
	bcs -
+
copy_backup_open_window_exit	
	rts	


	
	
	
close_edit_window
	jsr get_window_row_or_free_play_mode
	beq copy_backup_open_window_exit
	

	lda current_pattern_cmd_column
	beq +
	sta current_screen_column
+
	lda #0
	sta zp_ed_window_open_row
	sta zp_ed_glide_command
	sta current_pattern_cmd_column

	ldx #143
-	
	ldy #23
-
	lda $e100+7+40,x
	sta $b400+(start_row*40)+7+40,x

	lda $e100+7+200,x
	sta $b400+(start_row*40)+7+200,x

	lda $e100+7+360,x
	sta $b400+(start_row*40)+7+360,x

	lda $e100+7+520,x
	sta $b400+(start_row*40)+7+520,x

	cpx #120
	bcc +	
	lda $e100+7+680,y
	sta $b400+(start_row*40)+7+680,y
+	dex
	dey
	bpl -

	txa
	sbx #16
	bpl --	
	
	
	lda zp_ed_follow_play_mode
	ora zp_ed_free_play_mode
	beq +
	rts
+
	jsr convert_column_to_voice_x
	stx zp_ed_channel_temp+2
	
	lda pattern_memory_position,x
	sta zp_ed_scr_from_row+2	
	lda #0	;dont move cursor
	jmp update_pattern_screen_from_buffer	



update_background_colors
	jsr get_window_row_or_free_play_mode
	bne ++
		
	ldx #23				
-	
	lda $d800+(start_row*40)+7,x	;will fetch channel on/off colours	
	sta $d800+(start_row*40)+7+40,x
	
	jsr popup_top_5
	
	sta $d800+(start_row*40)+7+160,x
	sta $d800+(start_row*40)+7+280,x
	
	jsr popup_middle_4
	jsr popup_bottom_3
		
	cpx #23
	bne +
	lda #0
+
	sta $d800+(start_row*40)+7+200,x
	sta $d800+(start_row*40)+7+480,x
	
	dex
	bpl -
+	
	rts

init_free_play_window
	
	ldx #23
-	
	lda free_play_window+(0*23),x
	sta $b400+(start_row*40)+7+80,x	
	lda free_play_window+(1*23),x
	sta $b400+(start_row*40)+7+120,x
	lda free_play_window+(2*23),x
	sta $b400+(start_row*40)+7+160,x
	
	lda #$a0
	sta $b400+(start_row*40)+7+200,x
	
	lda free_play_window+(3*23),x
	sta $b400+(start_row*40)+7+240,x
	lda free_play_window+(4*23),x
	sta $b400+(start_row*40)+7+280,x
	lda free_play_window+(5*23),x
	sta $b400+(start_row*40)+7+320,x

	lda free_play_window+(6*23),x
	sta $b400+(start_row*40)+7+360,x
	sta $b400+(start_row*40)+7+400,x
	sta $b400+(start_row*40)+7+440,x	
	sta $b400+(start_row*40)+7+480,x
	
	lda free_play_window+(7*23),x
	sta $b400+(start_row*40)+7+520,x
	lda free_play_window+(8*23),x
	sta $b400+(start_row*40)+7+560,x
	lda free_play_window+(9*23),x
	sta $b400+(start_row*40)+7+600,x
	
	lda free_play_window+(10*23),x
	sta $b400+(start_row*40)+7+640,x
	lda free_play_window+(11*23),x
	sta $b400+(start_row*40)+7+680,x
	
	dex
	bne -
	sta zp_ed_backup_screen
	rts	
	
update_free_play_window
	;dec $d020
	
	lda #$0c
	ldy zp_ed_free_play_mode
	cpy #9
	bne +
	lax free_play_current_preset
	ora #$30
	sta $b400+(start_row*40)+6+163
	
	lda free_play_current_multispeed	;,x;free_play_layered_presets+6,y
	lsr
	lsr
	lsr
	lsr
	adc #$31
	sta $b400+(start_row*40)+8+163 
	
	
	lda #$01	
+	
	sta $d800+(start_row*40)+6+163
	sta $d800+(start_row*40)+8+163
	
	ldx #0
-	lda free_play_mode,y
	sta $b400+(start_row*40*3)+66,x
	iny
	inx
	cpx #4
	bcc -

	
		
	ldx #2
-
	txa
	pha
		
	ldy zp_ed_free_play_mode
	cpy #5
	beq +
	cpx free_play_current_channel
	beq +	
	lda #$0c
	.byte $0c
+	lda #$01
	cpy #1
	bne +
	cpx free_play_current_channel
	bne ++
+	ldy free_play_last_key_in_channel,x	;if 0, then color = $01 or $0c
	beq +
	lda #$05
+
	
	ldy mul6,x
	sta free_play_window_colours+53,y
	sta free_play_window_colours+54,y
	sta free_play_window_colours+56,y
	
	tya
	pha
	
	lda free_play_instruments,x
	sta zp_ed_scr_nybble_hi+2
		
	lda free_play_current_octave,x
	
	jsr convert_byte_to_text_scr_in_irq
	
	pla
	tax
	pha
	
	lda zp_ed_scr_nybble_lo+2
	sta $b400+(start_row*40)+14+163,x

	lda zp_ed_scr_nybble_hi+2
	
	jsr convert_byte_to_text_scr_in_irq
	
	pla
	tax
	tya
	sta $b400+(start_row*40)+11+163,x
	lda zp_ed_scr_nybble_lo+2
	sta $b400+(start_row*40)+11+163+1,x
	
	pla
	tax
	dex
	bpl -	

	
	ldx free_play_arpeggio_type
	ldy free_play_arpeggios,x
	
	ldx #3
-	lda free_play_arpeggios+3,y
	sta $b400+(start_row*40)+9+280,x 
	dey
	dex
	bpl -
	
	lda free_play_arpeggio_speed	
	jsr convert_byte_to_text_scr_in_irq
	sty $b400+(start_row*40)+16+280
	lda zp_ed_scr_nybble_lo+2
	sta $b400+(start_row*40)+17+280

	
	ldy #11
	lda free_play_glide_speed
	bmi +
	
	jsr convert_byte_to_text_scr_in_irq
	sty free_play_glide_SP+6	
	lda zp_ed_scr_nybble_lo+2
	sta free_play_glide_SP+7
	ldy #3
	
+	
	ldx #3
-	lda free_play_glide_SP+4,y
	sta $b400+(start_row*40)+20+280,x
	lda free_play_glide_SP,y
	sta free_play_window_colours+13+(4*23),x
	dey
	dex
	bpl -
	
	
	
		
update_free_play_window_colours	
	ldx #23
-	
	lda $d800+(start_row*40)+7,x	;will fetch channel on/off colours	
	sta $d800+(start_row*40)+7+40,x

	lda #$a0
	jsr popup_top_5
	sta $d800+(start_row*40)+7+200,x
	
	lda free_play_window_colours+(2*23),x
	sta $d800+(start_row*40)+7+160,x
	
	lda free_play_window_colours+(4*23),x
	sta $d800+(start_row*40)+7+280,x
	
	lda free_play_window_colours+(6*23),x
	jsr popup_middle_4
	sta $d800+(start_row*40)+7+480,x	
	
	lda free_play_window_colours+(8*23),x
	jsr popup_bottom_3

	dex
	bne -	
	;inc $d020		
	rts
popup_top_5
	sta $d800+(start_row*40)+7+80,x
	sta $d800+(start_row*40)+7+120,x
	sta $d800+(start_row*40)+7+240,x
	sta $d800+(start_row*40)+7+320,x
	sta $d800+(start_row*40)+7+680,x
	rts
	
popup_middle_4
	sta $d800+(start_row*40)+7+360,x
	sta $d800+(start_row*40)+7+400,x
	sta $d800+(start_row*40)+7+440,x
	sta $d800+(start_row*40)+7+520,x
	rts
popup_bottom_3	
	sta $d800+(start_row*40)+7+560,x
	sta $d800+(start_row*40)+7+600,x
	sta $d800+(start_row*40)+7+640,x
	rts
		