
	*=$0334


disc_io_init_variables
	.enc screen
	.text 0,0
	.text "sONGS",0,$60,"y",$60,0
	.text "sEQUENCES",0,$60,"y",$60,0
	.text "pATTERNS",0,$60,"y",$60,0
	.text "  lENGTH",0,$60,"64",$60,0
	.text "  sPEED",0,$60,"06",$60,0
	.text "iNSTRUMENTS",0,$60,"y",$60,0
	.text "tABLES",0,$60,"y",$60,0	
	;.text "hARD-RESTART FRAMES",0,$60,"02",$60,0	music routine only handles 2 frames atm
	.text 0,$60,$60,0	;skip line
	.text 0,$60,$75,"ok",$76,$60,0
	.enc none
disc_io_init_variables_end
disc_io_export_variables
	.enc screen	
	.text 0,0
	.text "dESTINATION",0,$60,"1000",0
	.text "zEROPAGE",0,$60,"fe (+1)",0
	.text 0,$60,$60,$60,0	;skip line
	.text 0,$60,$75,"ok",$76,$60,0
	.enc none		
disc_io_export_variables_end

disc_io_variables_function
	.word disc_io_decimal_string_to_byte
	.word disc_io_init_project_settings
disc_io_init_variables_values
	.byte "Y"-$40,"N"-$40
	.byte "Y"-$40,"N"-$40
	.byte "Y"-$40,"N"-$40
	.byte 2+$80,97
	.byte 2+$80,16
	.byte "Y"-$40,"N"-$40
	.byte "Y"-$40,"N"-$40
	.byte 0,0		;no possible choice
	.byte $e3,$e3		;enter only choice

	.word disc_io_hex_string_to_byte
	.word disc_io_relocate_and_export	
disc_io_export_variables_values
	.byte 0+$80,$f9
	.byte 2+$80,$ff
	.byte 0,0
	.byte $e3,$e3
		
	*=$0400
disc_io_start_screen	
	.byte 198,177,160,204,143,129,132,221,198,179,160,211,129,150,133,221,198,181,160,197,152,144,143,146,148,221,198,183,160,200,133,140,144,221,159,160,197,132,137,148
	.byte 192,192,192,192,192,192,192,219,192,192,192,192,192,192,192,241,192,192,242,192,192,192,192,192,192,241,192,192,192,242,192,192,192,241,192,192,192,192,192,192
	.byte 198,178,160,201,142,137,148,221,198,180,160,204,174,201,142,147,148,146,221,198,182,160,211,174,201,142,147,148,146,221,198,184,160,196,146,137,150,133,160,184
	.byte 32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32

	.binary "binaries/v1h.help.prg",0,(19*40)
						
	.byte 32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
	.byte 215,133,140,131,143,141,133,160,148,143,160,214,137,146,148,149,143,147,143,160,((>version_number)>>4)|$b0,174,((>version_number)&15)|$b0,((<version_number)>>4)|$b0,160,160,160,160,160,200,133,137,142,175,214,137,147,137,143,142		
	
	
	
	*=$c000
disc_main_menu
;	jsr return_io
;	jsr return_zeropage_values
	lda #$37
	sta $01
	jsr init_interrupts
	tya
	sta $d015
	
	lda #$0f
	jsr editor_init_song
	
	lda #3
	sta $dd00	
	lda #22
	sta $d018
	
	lda #$0d
	ldy #$00
	jsr init_editor_screen_colours
	
	ldx #119
	lda #$0a
-	sta $d800,x
	dex
	bpl -
	ldx #39
-	sta $dbc0,x
	dex
	bpl -
		
disc_io_startup nop disc_io_clear_screen
		
	lda #<irq_brk
	sta $0316
	sta $0318
	lda #>irq_brk
	sta $0317
	sta $0319
	lda #$1b
	sta $d011
	lda #$10
	sta $d012
	lda #<disc_io_irq
	sta $0314
	lda #>disc_io_irq
	sta $0315
	
	jsr $F32F	;Abort All Files (restore $98 zp) + Restore Default I/O
	lda $BA
	jsr disc_io_display_drive_no

	
disc_io_current	jsr disc_io_idle
	cli
	lda #1		;after some drive functions, set raster irq
	sta $d01a
	jmp disc_io_current
	

disc_io_irq
;	dec $d020
	jsr scan_keyboard
	
	cpx #0
	beq disc_io_no_function_key
	cpx #11
	bcs disc_io_no_function_key

	jsr disc_io_set_function
	
	
	
disc_io_no_function_key
	inc $d019
	jmp $ea81	
	
	
		

		
		


disc_io_load_project
	lda #"P"
	.byte $0c
disc_io_load_instruments
	lda #"I"
	jsr disc_io_directory
	jmp disc_io_init_file_selection	
	
				
disc_io_save_project

	lda #"P"
	jsr disc_io_directory
	jsr disc_io_check_ok_status
	bne disc_io_clear_function
	jmp disc_io_init_save

disc_io_save_instruments
	lda #"I"
	jsr disc_io_directory
	jsr disc_io_check_ok_status
	bne disc_io_clear_function	
	jmp disc_io_init_save_instruments
	
disc_io_load_help_file
	lda #"H"
	jsr disc_io_open_help_file
	jmp disc_io_clear_function
	

disc_io_return_to_editor
	jsr disc_io_clear_function
	jmp start_editor
	
	
disc_io_relocate_and_export
	lda #$00
	jsr disc_io_blink_cursor
	jsr pack_and_relocate_songs
	bcs disc_io_relocate_error
	lda #"E"
	jsr disc_io_directory
	jsr disc_io_check_ok_status
	bne disc_io_clear_function	
	jmp disc_io_init_export

disc_io_relocate_error	
	ldx #(disc_io_process_message_export_error-disc_io_process_messages)
	jsr disc_io_print_process_message_footer
	ldy #0
	sty zp_ed_disc_io_directory_files_index
	jmp disc_io_warm_start_init_screen

	
disc_io_toggle_drive_no
	lda #$08
	cmp $BA
	bcs +
	.byte $0c
+	lda #$09
	sta $BA
disc_io_display_drive_no	
	jsr convert_byte_to_text
	lda zp_ed_scr_nybble_lo
	ora #$b0
	sta $0477	
disc_io_clear_function
	ldx #0
disc_io_set_function
	lda disc_io_functions_lo,x
	sta disc_io_current+1
	lda disc_io_functions_hi,x
	sta disc_io_current+2	
	rts
			
;------------------------------------	
	
disc_io_init_project
	lda #(disc_io_process_message_init-disc_io_process_messages)	
	sta zp_ed_disc_io_directory_files_index
	ldx #0
	lda #(disc_io_init_variables-disc_io_init_variables)	
	ldy #(disc_io_init_variables_end-disc_io_init_variables)	
	bne disc_io_set_init_screen		

	
disc_io_export_songs
	lda #(disc_io_process_message_export-disc_io_process_messages)
	sta zp_ed_disc_io_directory_files_index
	ldx #(disc_io_export_variables_values-disc_io_init_variables_values)	
	lda #(disc_io_export_variables-disc_io_init_variables)
	ldy #(disc_io_export_variables_end-disc_io_init_variables)
	
disc_io_set_init_screen
	stx zp_ed_disc_io_directory_files_index+1

	sta disc_io_set_init_screen_start+1
	sty disc_io_set_init_screen_end+1

	lda disc_io_variables_function+2,x
	sta disc_io_init_confirm_action+1
	lda disc_io_variables_function+3,x
	sta disc_io_init_confirm_action+2

				
	jsr disc_io_clear_screen
	
	ldx zp_ed_disc_io_directory_files_index
	jsr disc_io_print_init_header
	
		
disc_io_set_init_screen_start
	ldx #0	
	ldy #40
disc_io_set_init_screen_loop	
	lda disc_io_init_variables,x
	bne +
	jsr disc_io_next_column
	ldy #40
	bne ++
+	sta (zp_ed_disc_io_lo),y
	iny
+	inx
disc_io_set_init_screen_end
	cpx #(disc_io_init_variables_end-disc_io_init_variables)
	bcc disc_io_set_init_screen_loop
	
;	jsr disc_io_reset_variables_user_settings
disc_io_reset_variables_user_settings
	ldy #(disc_io_init_variables_default_settings_end-disc_io_init_variables_default_settings)
-	lda disc_io_init_variables_default_settings-1,y
	sta disc_io_init_variables_user_settings-1,y
	dey
	bne -
;	rts

disc_io_warm_start_init_screen		
	;lda #3
	;sta disc_io_cursor_end+1
	lda #1
	sta zp_ed_disc_io_cursor_move_type
	lda #4
	sta zp_ed_disc_io_file_size_decimal
	lda #5	
	jmp disc_io_init_selection

		
;==========================	

disc_io_clear_screen
	ldy #0
	ldx #0
	stx zp_ed_disc_io_inverse	
	lda #$20
-	
	sta $0478,y
	sta $0578,x
	sta $0678,x
	sta $06e8,x
	cpy #$ff
	beq +
	iny
+	inx
	bne -
	;lda #$20	;jsr
	sta disc_io_startup
disc_io_idle	rts


disc_io_print_footer_checking_message
	ldx #0
disc_io_print_process_message_footer_padded	
	jsr disc_io_set_disc_footer_index
	bne disc_io_print_process_message_padded	
disc_io_print_init_header
	jsr disc_io_set_disc_header_index
disc_io_print_process_message_padded
	jsr disc_io_print_process_message
disc_io_print_directory_header_padded	
-	sta (zp_ed_disc_io_lo),y
	iny
	cpy #40
	bcc -
	rts
		
disc_io_print_process_message_footer
	jsr disc_io_set_disc_footer_index
disc_io_print_process_message	
	ldy #0
-	lda disc_io_process_messages,x
	cmp #160
	beq +
	inx
+	sta (zp_ed_disc_io_lo),y
	iny
	cpy #20
	bcc -
	rts
	
				
disc_io_set_disc_footer_index
	lda #$c0
	sta zp_ed_disc_io_lo	
	lda #$07
	bne +
disc_io_set_disc_header_index
	lda #$a0
	sta zp_ed_disc_io_lo
	lda #$04
+	sta zp_ed_disc_io_hi
	rts	

	
		
disc_io_next_column	
	lda zp_ed_disc_io_lo
	clc	
	adc #20
	sta zp_ed_disc_io_lo
	bcc +
	inc zp_ed_disc_io_hi
+	rts
	
disc_io_screen_file_size		
	ora #$30
	ora zp_ed_disc_io_inverse
	sta (zp_ed_disc_io_lo),y
	rts		
;=====================================
disc_io_output_char
;chr$()
	cmp #$20
	bcs +
	lda #$20
+	cmp #$60
	bcc +
	and #$df
	bne ++
+	and #$3f
+	rts
disc_io_input_char
	cmp #$20
	bcc +
	cmp #$40
	bcc ++
	adc #$1f
	bpl ++
	sbc #$1f
+	adc #$40
+	rts	

disc_io_slow_down_user	
-	bit $d011
	bpl -
-	ldx zp_ed_keyboard_speed
	bne -
	rts
	
disc_io_clear_file_name
	ldx #12
	lda #" "
-	sta disc_io_file_name+4,x
	dex
	bpl -
	rts	
;=====================================				
disc_io_print_open_error
;in:A=error code

	tay
	asl
	tax
	jsr disc_io_set_disc_footer_index
	tya
	jsr convert_byte_to_text
	ldy #0
	jsr disc_io_invert_char_poke
	inc zp_ed_disc_io_lo
	lda zp_ed_scr_nybble_lo
	jsr disc_io_invert_char_poke
	inc zp_ed_disc_io_lo
	lda #","+128
	sta (zp_ed_disc_io_lo),y
	inc zp_ed_disc_io_lo
	lda $A328-2,x	;message pointer lo
	sta zp_ed_disc_io_file_size_decimal+0
	lda $A329-2,x
	sta zp_ed_disc_io_file_size_decimal+1
disc_io_get_message	
	lda (zp_ed_disc_io_file_size_decimal),y
	jsr disc_io_output_char
	and #$3f	
	jsr disc_io_invert_char_poke
	bcs +
	iny
	bne disc_io_get_message
+	rts
	
			
;=====================================				
disc_io_test_file_extension	
	txa
	pha
	ldy #4
	
	ldx #0	
	stx zp_ed_disc_io_directory_files_index
	lda #$24	;bit $ff
-
	sta disc_io_opcode
disc_io_opcode	bit zp_ed_disc_io_directory_files_index
	jsr disc_io_directory_getbyte
	beq disc_io_test_file_extension_exit	;end of line
	
	cmp disc_io_file_extension,x
	beq disc_io_found_char
		
	cmp disc_io_file_blocks_free,x
	bne disc_io_opcode

	iny
disc_io_found_char
	lda #$e6	;inc $ff
	
disc_io_char_x	cpx zp_ed_disc_io_directory_files_index
	bne disc_io_test_file_extension_exit
	inx
	cpx #5
	bcc -
	
	lda #$00
;test ok (y=4:file found or y=9:blocks free found)
	cpy #4
	beq +
	cpy #9
	bne disc_io_test_file_extension_exit
	iny
	lda #$d4
	jsr disc_io_set_disc_footer_index+2
	
	lda #$80
+
	sta zp_ed_disc_io_inverse
	sty zp_ed_disc_io_directory_files_index
	
	ldy #0
	jsr disc_io_word_to_decimal
	beq +
	jsr disc_io_screen_file_size
+	iny
	ora zp_ed_disc_io_file_size_decimal+1
	beq +
	lda zp_ed_disc_io_file_size_decimal+1
	jsr disc_io_screen_file_size
+	iny
	ora zp_ed_disc_io_file_size_decimal+0
	beq +
	lda zp_ed_disc_io_file_size_decimal+0
	jsr disc_io_screen_file_size
+	iny
	txa
	jsr disc_io_screen_file_size

	iny
	
	lda #$60
		
	cpy zp_ed_disc_io_directory_files_index
	beq +
-
	lda disc_io_file_blocks_free-5,y
	and #$3f
+
	jsr disc_io_screen_file_size+2
	iny
	cpy zp_ed_disc_io_directory_files_index
	bcc -
	.byte $80
			
disc_io_test_file_extension_exit
	clc
	pla
	tax
	rts	

	
;=====================================
disc_io_set_secondary_address_chkout
	lda #$c9	;chkout
	.byte $0c
disc_io_set_secondary_address
;in: Y=secondary address (0 for dir, 15 for status, 2 for read/write)
	
	lda #$c6	;chkin
	sta disc_io_chkin_chkout+1
	
	lda #$02      ; file number 2
	ldx $BA       ; last used device number
	bne +
	ldx #$08      ; default to device 8
+	jsr $FFBA     ; call SETLFS
	jsr $FFC0     ; call OPEN
	bcs disc_io_open_error    ; if carry set, the file could not be opened
	ldx #$02      ; filenumber 2
disc_io_chkin_chkout		
	jmp $FFC6     ; call CHKIN (file 2 now used as input)	
disc_io_open_error
	; akkumulator contains basic error code
	
	jsr disc_io_print_open_error
	pla	;pull return address, no need to return from disc_io_set_secondary_address
	pla
	jmp disc_io_eof_close
	
	
		
;reading the directory
;================================================

disc_io_directory
	sta disc_io_file_name+2
	jsr disc_io_clear_screen
		
	
	jsr disc_io_print_footer_checking_message
	jsr disc_io_set_disc_header_index
	
	
	
	lda #disc_io_directory_dirname_end-disc_io_directory_dirname
	ldx #<disc_io_directory_dirname
	ldy #>disc_io_directory_dirname
	jsr $FFBD	; call setnam
	
	ldy #$00
	jsr disc_io_set_secondary_address
	
	ldy #$05	; skip 5 bytes on the first dir line
	.byte $0c
disc_io_directory_next
	ldy #$02	; skip 2 bytes on all other lines
	tya
	tax
-	
	jsr disc_io_directory_getbyte	; get a byte from dir and ignore it
	dey
	bne -
		
	jsr disc_io_directory_getbyte    ; get low byte of basic line number
	sta zp_ed_disc_io_file_size
	
	jsr disc_io_directory_getbyte    ; get high byte of basic line number
	sta zp_ed_disc_io_file_size+1

	cpx #5
	beq disc_io_directory_char
	
	jsr disc_io_test_file_extension
	bcc disc_io_directory_next
	
disc_io_directory_char

	jsr disc_io_directory_getbyte
	beq disc_io_directory_eol
	cpx #5
	beq +

	cpy #18
	bcs disc_io_directory_eol
+			
	jsr disc_io_output_char
	cpx #5
	bne +
	ora #$80
+	cmp #$22	;quotes test
	bne +
disc_io_directory_end_char	
	lda #$60
+	jsr disc_io_screen_file_size+2
	iny
	bne disc_io_directory_char
		
	
	
disc_io_directory_eol
	cpx #5
	bne +
	lda #$a0	;fill up header
	jsr disc_io_print_directory_header_padded
	lda #$a0+60
	sta zp_ed_disc_io_lo
+	
	jsr disc_io_next_column
	;lda zp_ed_disc_io_lo
	cmp #$98
	bne disc_io_directory_next
	ldx #disc_io_process_message_select_file-disc_io_process_messages	
	jsr disc_io_print_process_message_footer
	
	lda #$c0+20
	jsr disc_io_set_disc_footer_index+2
	ldx #disc_io_process_message_next_page-disc_io_process_messages	
	jsr disc_io_print_process_message
	
-	ldx zp_ed_keyboard_current
	cpx #" "
	bne +
	ldy #80
	jsr disc_io_clear_screen+2
	jsr disc_io_print_footer_checking_message
	lda #$a0+80
	jsr disc_io_set_disc_header_index+2
	bne disc_io_directory_next	
+	
	cpx #$e3
	bne -
	
	ldx #0
	stx zp_ed_keyboard_current
	jsr disc_io_print_footer_checking_message
	bcs disc_io_close_channel	
	
disc_io_directory_end
	pla
	pla
	bne disc_io_close_channel
	
disc_io_directory_getbyte
	jsr $FFB7	; call readst (read status byte)
	bne disc_io_directory_end       ; read error or end of dir
	jmp $FFCF	; call chrin (read byte from directory)


	
	
;===============================================

	

disc_io_init_export

	lda #4
	sta zp_ed_disc_io_directory_files_index
	ldx #13
	jsr disc_io_set_function
	jsr disc_io_clear_file_name

disc_io_export_file
	jsr disc_io_set_file_name
	bcs +
	rts
+
	
	ldx #0
	stx $d01a
	jsr disc_io_set_function
	
	lda #disc_io_write_file_name_end-disc_io_file_name
	ldx #<disc_io_file_name
	ldy #>disc_io_file_name
	jsr $FFBD     ; call setnam
	
	ldy #2	;secondary address 2
	jsr disc_io_set_secondary_address_chkout
	

	
	ldx #disc_io_process_message_exporting-disc_io_process_messages
	jsr disc_io_print_process_message_footer
		

relocator_destination_lo		
	lda #<relocator_destination
	sta zp_ed_disc_io_lo
relocator_destination_hi	
	lda #>relocator_destination
	sta zp_ed_disc_io_hi
	
	ldy #$00
-	jsr $FFB7     ; call readst (read status byte)
	bne disc_io_close_channel   ; write error
	
	ldx $01
	
	jsr init_io_ram
	
	lda (zp_ed_disc_io_lo),y   ; get byte from memory
	
	stx $01
	
	jsr $FFD2     ; call chrout (write byte to file)
	inc zp_ed_disc_io_lo
	bne +
	inc zp_ed_disc_io_hi
+
	lda zp_ed_disc_io_lo
relocator_destination_end_lo	
	cmp #0
	lda zp_ed_disc_io_hi
relocator_destination_end_hi	
	sbc #0
	bcc -     ; next byte

	jsr disc_io_eof_close
	;show dir after successfull export
	lda #"E"
	jmp disc_io_directory
	
disc_io_close_channel	
	jsr disc_io_eof_close
	jmp disc_io_status
	
;===============================================
	
disc_io_open_help_file
	sta disc_io_file_name+2
	lda #"*"
	sta disc_io_file_name+4

	ldx #0
	jsr disc_io_clear_screen
	jsr disc_io_print_footer_checking_message
;	jsr disc_io_set_disc_header
	lda #$0c	;nop $eaea
	sta disc_io_startup	
	lda #5
	ldx #<disc_io_file_name
	ldy #>disc_io_file_name
	jsr $FFBD     ; call SETNAM

	ldy #2	
	jsr disc_io_set_secondary_address

disc_io_open_help_next_page
		
	ldx #disc_io_process_message_loading-disc_io_process_messages
	jsr disc_io_print_process_message_footer_padded
	
	jsr disc_io_set_disc_header_index
	
	ldy #$00
-	jsr $FFB7     ; call READST (read status byte)
	bne disc_io_close_channel    ; either EOF or read error
	jsr $FFCF     ; call CHRIN (get a byte from file)
	beq disc_io_open_help_check_page
	sta (zp_ed_disc_io_lo),y   ; write byte to screen
	iny
	bne -
	inc zp_ed_disc_io_hi
	bne -

	
disc_io_open_help_check_page
	jsr disc_io_slow_down_user			
			
-	lda zp_ed_keyboard_current
	cmp #$e3	;enter key
	beq disc_io_close_channel
	cmp #" "
	bne -	
+	
	stx zp_ed_keyboard_current
	jsr disc_io_set_disc_footer_index	
	jmp disc_io_open_help_next_page
		
;-------------------------------------

disc_io_set_file_name

	ldy zp_ed_disc_io_directory_files_index
	jsr disc_io_slow_down_user
	
	lda zp_ed_keyboard_current
	stx zp_ed_keyboard_current
	
	beq disc_io_set_file_name_cursor
	bpl disc_io_set_file_name_key
	
	cmp #$ee
	beq disc_io_set_file_name_left
	cmp #$ec
	beq disc_io_set_file_name_right
	cmp #$e7
	beq disc_io_set_file_name_back_space
	cmp #$e6
	beq disc_io_set_file_name_insert_space
	cmp #$e3
	bne disc_io_set_file_name_cursor
	sec
	rts
disc_io_set_file_name_insert_space
	sty zp_ed_disc_io_file_name_length
	ldy #15
-	lda disc_io_file_name-1,y
	sta disc_io_file_name,y
	dey
	cpy zp_ed_disc_io_file_name_length
	bcs -
	iny
	lda #" "
	sta disc_io_file_name,y
	clc
	rts
	
disc_io_set_file_name_back_space
	tya
	pha
	cpy #5
	bcc +
	dey
+
-	
	lda disc_io_file_name+1,y
	sta disc_io_file_name,y
	iny
	cpy #15
	bcc -
	lda #" "
	sta disc_io_file_name,y
	pla
	tay
	 
disc_io_set_file_name_left
	
	dey
	cpy #4
	bcs disc_io_set_file_name_cursor
disc_io_set_file_name_right
	iny
	cpy #16
	bcc disc_io_set_file_name_cursor
	dey
	bcs disc_io_set_file_name_cursor
	
disc_io_set_file_name_key
	and #$3f
	jsr disc_io_input_char
	sta disc_io_file_name,y
	jmp disc_io_set_file_name_right
	
disc_io_set_file_name_cursor
	sty zp_ed_disc_io_directory_files_index
	
	jsr disc_io_set_disc_footer_index
	
	ldy #0
	lda #$a2
	sta (zp_ed_disc_io_lo),y
	inc zp_ed_disc_io_lo
	
	
-	
	lda disc_io_file_name,y
	jsr disc_io_output_char
	cpy zp_ed_disc_io_directory_files_index
	jsr disc_io_invert_char_poke_

	iny
	cpy #16
	bcc -
	lda #$a2
	sta (zp_ed_disc_io_lo),y
	clc
disc_io_save_file_exit	
-	rts

		
;========================================	
;used for saving projects (considering cartridge speeders)

disc_io_init_save_instruments

	lda #<instrument_data_end
	sta zp_ed_disc_io_file_size
	lda #>instrument_data_end
	sta zp_ed_disc_io_file_size+1
	
	ldx #<instrument_data_start	;file start lo
	ldy #>instrument_data_start	;file start hi	
	bne disc_io_save_file_init_file_name
	
disc_io_init_save
	
disc_io_set_project_version_number	
	lda #((>version_number)>>4)|$30
	ldx #((>version_number)&15)|$30
	ldy #((<version_number)>>4)|$30
	sta project_header+9
	stx project_header+11
	sty project_header+12

		
	lda #0
	sta zp_ed_disc_io_file_size+1
	
;check highest used pattern
	ldx #2
-
	txa
	clc
	adc #>sequencer_data_start
	sta zp_ed_disc_io_hi
	
	ldy #0
	sty zp_ed_disc_io_lo
-	lda (zp_ed_disc_io_lo),y
	cmp #max_number_of_patterns
	bcs +
	cmp zp_ed_disc_io_file_size+1
	bcc ++
	sta zp_ed_disc_io_file_size+1	;new highest pattern used	
	bcs ++	
+	
	cmp #loop
	bne +
	iny		;loop position is not a pattern, skip it
+
	iny	
	cpy #$f8		;free play sequences start at #$f8 index
	bcc -
	dex
	bpl --
	
	lda #0	;file end lo
	sta zp_ed_disc_io_file_size
	lda zp_ed_disc_io_file_size+1
	;sec
	adc #>patterns
	sta zp_ed_disc_io_file_size+1	;file end hi
	
	ldx #<project_file_start	;file start lo
	ldy #>project_file_start	;file start hi
	
disc_io_save_file_init_file_name

	stx $c1
	sty $c2
		
	lda #4
	sta zp_ed_disc_io_directory_files_index
	
	ldx #11
	jsr disc_io_set_function

	jsr disc_io_clear_file_name
		
;------------	
disc_io_save_file
	jsr disc_io_set_file_name
	bcc disc_io_save_file_exit
	
		
	ldx #0
	stx $d01a
	jsr disc_io_set_function	
	
;reset some status line numbers for AR/Basic (in case disc is full or whatnot)
	stx $D3	;cursor
	stx $D5	;logical line length (added to 39 from AR)
	lda #3	
	sta $D6	;just above first files on disc
	sta $C7	;reverse mode for status message

		
	lda #disc_io_file_name_end-disc_io_file_name
	ldx #<disc_io_file_name
	ldy #>disc_io_file_name
	jsr $FFBD     ; call SETNAM
	
	lda #$02
	ldx $BA       ; last used device number
	bne +
	ldx #$08      ; default to device 8
+	ldy #$00
	jsr $FFBA     ; call SETLFS

	ldx #disc_io_process_message_saving-disc_io_process_messages
	jsr disc_io_print_process_message_footer
		
	ldx zp_ed_disc_io_file_size
	ldy zp_ed_disc_io_file_size+1
	lda #$C1      ; start address located in $C1/$C2
	jsr $FFD8     ; call SAVE
	
	bcc disc_io_status    ; if carry set, a save error has happened
disc_io_print_open_error_		      ; if carry clear, might also be file exist
	jmp disc_io_print_open_error
	



		
;===============================================	
disc_io_status	
	jsr disc_io_set_disc_footer_index
	
	lda #0      ; no filename
	tax
	tay
	jsr $FFBD     ; call SETNAM
	
	ldy #$0f
	jsr disc_io_set_secondary_address
	
	ldy #0
-	jsr $FFB7     ; call READST (read status byte)
	bne +      ; either EOF or read error
	jsr $FFCF     ; call CHRIN (get a byte from file)
	jsr disc_io_output_char
	jsr disc_io_invert_char_poke
	iny
	bne -     ; next byte
	
+
	lda #20
	cpy #20
	bcc +
	lda #40	
+	sta zp_ed_disc_io_file_name_length	

	lda #$a0
-
	sta (zp_ed_disc_io_lo),y
	iny
	cpy zp_ed_disc_io_file_name_length
	bcc -

	

disc_io_eof_close
	lda #$02	; filenumber 2
	jsr $FFC3	; call close
	jmp $FFCC	; call CLRCHN
disc_io_check_ok_status	
;crap, but alas
	ldy #0
	lda (zp_ed_disc_io_lo),y
	iny
	ora (zp_ed_disc_io_lo),y
	and #$0f
	rts
;---------------------
disc_io_load_file
	
	lda zp_ed_disc_io_file_name_length
	bne +
disc_io_load_file_exit	
-	rts
+	
;clear project in memory
	
	ldx #<disc_io_file_name
	ldy #>disc_io_file_name
	jsr $FFBD     ; call SETNAM
	
	lda #$02	; filenumber
	ldx $BA       ; last used device number
	bne +
	ldx #$08      ; default to device 8
+	ldy #$01      ; not $01 means: load to address stored in file
	jsr $FFBA     ; call SETLFS

	ldx #disc_io_process_message_loading-disc_io_process_messages
	jsr disc_io_print_process_message_footer

	;added for longer filenames
	lda #"*"
	sta disc_io_file_name+16
			
	lda #$00      ; $00 means: load to memory (not verify)
	jsr $FFD5     ; call LOAD
	bcs disc_io_print_open_error_     ; if carry set, a load error has happened
	
	
	jsr disc_io_status
	
	lda disc_io_file_name+2
	cmp #"P"
	bne disc_io_load_file_exit

	;reset remaining empty patterns to project length		
	lda project_pattern_length
	sta disc_io_init_variables_user_settings+3
	
	ldx #12	;reset function to file selection
	lda $AF	;end of file hi, start of pattern re-init
	jmp disc_io_clear_patterns_after_load


;------------------------------
		
disc_io_init_file_selection
	lda #11
	sta zp_ed_disc_io_file_name_length
	ldy #0
	sty zp_ed_disc_io_cursor_move_type
	
	lda #$c8+4+40
	sta zp_ed_disc_io_file_size_decimal	
	lda #$04
	
disc_io_init_selection	
	sta zp_ed_disc_io_file_size_decimal+1
		
	;lda #0
	sty zp_ed_disc_io_directory_files_index
	
	ldx #12
	jsr disc_io_set_function
		
		
disc_io_select_file
	jsr disc_io_slow_down_user

disc_io_select_move_cursor	
	ldx zp_ed_keyboard_current
	beq disc_io_move_cursor_exit
		
	lda #$00
	jsr disc_io_blink_cursor
	
	ldy zp_ed_disc_io_file_size_decimal+1
	tya
	pha
	lda zp_ed_disc_io_file_size_decimal
	pha
	
	cpx #$ef
	beq disc_io_select_file_down
	cpx #$ee
	beq disc_io_select_file_left
	cpx #$ed
	beq disc_io_select_file_up
	cpx #$ec
	bne disc_io_select_file_cursor_fixed
	
disc_io_select_file_right
+	adc #19
	jmp disc_io_select_file_cursor_down_right	
	
disc_io_select_file_left
+	sbc #20
	jmp disc_io_select_file_cursor_up_left

disc_io_select_file_down
	adc #39
	inc zp_ed_disc_io_directory_files_index
	ldx zp_ed_disc_io_cursor_move_type	
	beq +
	ldx #1
	stx zp_ed_disc_io_cursor_move_type
+	
disc_io_select_file_cursor_down_right
	tax	
	tya
	adc #0
	bcc disc_io_select_file_cursor
		
disc_io_select_file_up
	dec zp_ed_disc_io_directory_files_index
	sbc #40
	ldx zp_ed_disc_io_cursor_move_type	
	beq +
	ldx #1
	stx zp_ed_disc_io_cursor_move_type
+	
disc_io_select_file_cursor_up_left
	tax
	tya
	sbc #0
disc_io_select_file_cursor

	sta zp_ed_disc_io_file_size_decimal+1
	stx zp_ed_disc_io_file_size_decimal

		
disc_io_select_file_cursor_init		
	
disc_io_select_file_cursor_fixed
	lda #$80
	jsr disc_io_blink_cursor
	pla
	tay
	pla
	
	ldx zp_ed_disc_io_file_name_length
	cpx #4
	beq disc_io_select_move_cursor
	bcc +
	cpx #6
	bcs disc_io_select_file_check_enter
	
+		
	sty zp_ed_disc_io_file_size_decimal
	sta zp_ed_disc_io_file_size_decimal+1
	
disc_io_cursor_line_number_previous
	
	lda zp_ed_disc_io_file_size
	sta zp_ed_disc_io_directory_files_index
	
disc_io_move_cursor_exit
disc_io_cursor_line_number
	lda zp_ed_disc_io_directory_files_index
	sta zp_ed_disc_io_file_size
	lda #0
	sta zp_ed_keyboard_current
	lda #$80
	jmp disc_io_blink_cursor
	
		

disc_io_select_file_check_enter
	ldx zp_ed_keyboard_current		
	ldy zp_ed_disc_io_cursor_move_type
	bne disc_io_check_init_keys
	
	cpx #$e3
	bne disc_io_check_init_keys
	
	jmp disc_io_load_file
	
;----------------------
	
disc_io_check_init_keys

	
	lda zp_ed_disc_io_directory_files_index
	asl
	adc zp_ed_disc_io_directory_files_index+1	
	tax
	ldy #2
-
	lda disc_io_init_variables_values,x
	bmi disc_io_init_numeric_value
	dey
	bmi disc_io_move_cursor_exit	
	inx
	cmp zp_ed_keyboard_current
	bne -
	
	
	ldy #1
	ora #$c0
	sta (zp_ed_disc_io_file_size_decimal),y	
	
	anc #1		;flag Y/N
	ldx zp_ed_disc_io_directory_files_index
	sta disc_io_init_variables_user_settings,x
	bcc disc_io_move_cursor_exit

	
disc_io_init_numeric_value
	cmp zp_ed_keyboard_current	;only enter ($e3) is equal to possible table value
	bne +
disc_io_init_confirm_action	
	jmp disc_io_init_project_settings
+	

	ldy zp_ed_disc_io_cursor_move_type
	lda (zp_ed_disc_io_file_size_decimal),y
	pha
	
	lda zp_ed_keyboard_current
	and #$3f
	tax
	jsr check_and_convert_hex_nybble
	bcs disc_io_move_cursor_exit_pull_stack
	
	
	ldy zp_ed_disc_io_cursor_move_type
	txa
	ldx zp_ed_disc_io_directory_files_index+1	
	cmp #$30
	bcs +
	
	cpx #0	
	beq disc_io_move_cursor_exit_pull_stack
	
	ora #$40
+	sta (zp_ed_disc_io_file_size_decimal),y
	
	lda disc_io_variables_function,x
	sta disc_io_numeric_conversion+1
	lda disc_io_variables_function+1,x
	sta disc_io_numeric_conversion+2

		
	lda zp_ed_disc_io_directory_files_index
	asl
	adc zp_ed_disc_io_directory_files_index+1	
	tay		
	lda disc_io_init_variables_values,y
	and #$7f
	sta disc_io_decimal_compare_value_low+1
	
	lda disc_io_init_variables_values+1,y
	sta disc_io_decimal_compare_value_high+1


	
disc_io_numeric_conversion
	jsr disc_io_decimal_string_to_byte
		
disc_io_decimal_compare_value_low
	cmp #0
	bcc disc_io_move_cursor_exit_jump	
disc_io_decimal_compare_value_high
	cmp #0	
	bcs disc_io_move_cursor_exit_jump	

	pha
	lda zp_ed_disc_io_directory_files_index+1
	lsr
	adc zp_ed_disc_io_directory_files_index
	tax
	pla		
	sta disc_io_init_variables_user_settings,x
	
	lda zp_ed_disc_io_cursor_move_type
	eor #3
	sta zp_ed_disc_io_cursor_move_type
disc_io_move_cursor_exit_pull_stack	
	pla
	jmp disc_io_move_cursor_exit
	
disc_io_move_cursor_exit_jump
	ldy zp_ed_disc_io_cursor_move_type
	pla	
	sta (zp_ed_disc_io_file_size_decimal),y
-	
	jmp disc_io_move_cursor_exit

	
	
	
;------------------	
		
disc_io_init_project_settings


;	jsr disc_io_clear_song_settings
	

disc_io_clear_song_settings			
	sei	;no interruption of clear process

	lda disc_io_init_variables_user_settings
	beq disc_io_clear_sequences
	ldx #$f0
	lda #" "
-	sta song_names-1,x
	dex
	bne -
	
	ldx #$3c
-	
	txa
	and #3
	bne +
	lda song_pattern_settings-1,x
	and #$0f
	.byte $0c
+	lda #<sequencer_data_start
	sta song_pattern_settings-1,x
	dex
	bne -

	
disc_io_clear_sequences

	lda disc_io_init_variables_user_settings+1
	beq disc_io_clear_instruments

	ldx #$f8
	ldy #end
-	tya
-	sta s0_v1_patterns-1,x	
	sta s0_v2_patterns-1,x
	sta s0_v3_patterns-1,x
	dex
	cpx #4
	bcs -
	lda #0
	cpx #3
	bcs -
	dey
	cpx #2
	bcs --
	cpx #1
	bcs -

	
disc_io_clear_instruments

	lda #>adsr_table_cmd
	ldx #0
	sta zp_ed_disc_io_hi
	stx zp_ed_disc_io_lo

	lda disc_io_init_variables_user_settings+5
	beq disc_io_clear_instrument_tables

	
	lda #" "
-	sta instrument_names_copy_start,x
	sta instrument_names+$100,x
	inx
	bne -
	txa
	ldx #8
-	sta instruments,x
	inx
	bne -

disc_io_clear_instrument_tables

	ldx disc_io_init_variables_user_settings+6
	beq disc_io_clear_patterns
	lda #0		
-	
	ldy #$ff
-	
	sta (zp_ed_disc_io_lo),y
	dey
	bne -
	inc zp_ed_disc_io_hi
	ldx zp_ed_disc_io_hi
	cpx #>rhythm_speeds
	bcc --
-	sta rhythm_speeds+1,y		
	sta hard_table_1st_frame,y
	iny
	bpl -

	
	
		
disc_io_clear_patterns
	ldx disc_io_init_variables_user_settings+2
	beq ++
	
	;init user pattern speed
	ldx #$40
-	lda disc_io_init_variables_user_settings+4
	sta song_pattern_settings-5,x
	txa
	sbx #4
	bne - 
	

	ldx #10	;return function after clear	
	
	lda #>pattern00
disc_io_clear_patterns_after_load
	ldy #<pattern00	
	sty zp_ed_disc_io_lo
	
	sta zp_ed_disc_io_hi		
	
-
	cmp #>pattern50
	bcc +
	jmp disc_io_set_function
+
	ldy #0
	tya
-	sta (zp_ed_disc_io_lo),y
	iny
	bne -
	
	lda disc_io_init_variables_user_settings+3
	bne +
	lda disc_io_init_variables_default_settings+3
+	sta project_pattern_length
	clc
	adc #dur00-1
	sta (zp_ed_disc_io_lo),y
	iny
	iny
	lda #end
	sta (zp_ed_disc_io_lo),y
	
	inc zp_ed_disc_io_hi
	lda zp_ed_disc_io_hi			
	bne --
	

	
;---------------------
;===============================================	
disc_io_decimal_string_to_byte
	ldy #1
	lda (zp_ed_disc_io_file_size_decimal),y
	and #$0f
	tax
	iny
	lda (zp_ed_disc_io_file_size_decimal),y
	and #$0f
	cpx #0
	beq +
-	clc
	adc #$0a
	dex
	bne -
+	
	rts

disc_io_hex_string_to_byte	
	ldy #1
	lda (zp_ed_disc_io_file_size_decimal),y
	sec
	jsr check_and_convert_hex_nybble
	sta zp_ed_disc_io_hi
	ldy #2
	lda (zp_ed_disc_io_file_size_decimal),y
	clc
	jsr check_and_convert_hex_nybble
	ora zp_ed_disc_io_hi
	rts
					
disc_io_word_to_decimal

	sed
	sty zp_ed_disc_io_file_size_decimal+0
	sty zp_ed_disc_io_file_size_decimal+1
		
	ldx #15
	
-	asl zp_ed_disc_io_file_size+0
	rol zp_ed_disc_io_file_size+1
	lda zp_ed_disc_io_file_size_decimal+0
	adc zp_ed_disc_io_file_size_decimal+0
	sta zp_ed_disc_io_file_size_decimal+0
	lda zp_ed_disc_io_file_size_decimal+1
	adc zp_ed_disc_io_file_size_decimal+1
	sta zp_ed_disc_io_file_size_decimal+1
	dex
	bpl -
	cld
	pha
	pha
	
	lda zp_ed_disc_io_file_size_decimal+0
	and #$0f
	tax
			
	lsr zp_ed_disc_io_file_size_decimal+0
	lsr zp_ed_disc_io_file_size_decimal+0
	lsr zp_ed_disc_io_file_size_decimal+0
	lsr zp_ed_disc_io_file_size_decimal+0
	
	pla
	and #$0f
	sta zp_ed_disc_io_file_size_decimal+1 
	
	pla
	lsr
	lsr
	lsr
	lsr
	rts	
;---------	
disc_io_blink_cursor
	sta zp_ed_disc_io_inverse
	
	ldy #0	
	lda (zp_ed_disc_io_file_size_decimal),y
	cmp #$60
	bne disc_io_cursor_not_valid

	ldy zp_ed_disc_io_cursor_move_type
	beq +
	iny
	sty zp_ed_disc_io_file_name_length
	dey
	dey
+
	iny
-	
	lda (zp_ed_disc_io_file_size_decimal),y
	cmp #$60
	beq ++
	and #$7f
	cmp #$75
	bne +
	sta zp_ed_disc_io_file_name_length	
+	pha
	jsr disc_io_input_char
	sta disc_io_file_name+3,y
	pla
	ora zp_ed_disc_io_inverse
	sta (zp_ed_disc_io_file_size_decimal),y
	iny
;disc_io_cursor_end	
	cpy zp_ed_disc_io_file_name_length
	bcc -
	iny
+	iny
	iny
	iny
disc_io_cursor_not_valid	
	sty zp_ed_disc_io_file_name_length	
	rts
			
disc_io_invert_char_poke_
	beq +
disc_io_invert_char_poke
	ora #$80
+	sta (zp_ed_disc_io_lo),y
	rts
	

		